package remoteSystem;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GraphicsEnvironment;
import java.awt.GridLayout;
import java.awt.HeadlessException;
import java.awt.Point;
import java.awt.TextField;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.ClipboardOwner;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.LinkedList;
import remoteSystem.Transfer.DlFile;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.table.AbstractTableModel;

public class DlTableModel extends AbstractTableModel{
	
	private static final long serialVersionUID = 1L;
	
	private LinkedList dlFile = Transfer.getDlFile();
	private String[][] data = new String[dlFile.size()][11];
	private String[] header = {"Fortschritt", "Name", "Status", "Prioritt", "Gre", "Fertiggestellt", "Geschwindigkeit", "Quellen", "Kategorie"};
	private int sortCol = 8;
	private boolean inv = false;
	
	public DlTableModel(){
	}

	//PopUp-Men
	public synchronized JPopupMenu getPopUp(int row){
		final int row2 = row;
		final String name = data[row2][1];
		final String hash = data[row2][9];
		final String status = data[row][2];
		final String priority = data[row][3];
		final String comments = data[row][10];
		final String cat = data[row][8];
		final int dataLength = data.length;
		JPopupMenu pop = new JPopupMenu();
		//die richtigen Meneintrge fr die richtigen dateien
		JMenuItem item1;
		JMenuItem item2;
		JMenuItem item3;
		JMenuItem item4;
		JMenuItem item5;
		JMenuItem item6;
		JMenuItem item7;
		JMenuItem item8;
		JMenu item9;
		JMenu item10;
		if (status.equals("Vollstndig")){
			item1 = new JMenuItem("Fertige Datei ausblenden", new ImageIcon(getClass().getResource("l_clear.gif")));
			item1.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent arg0) {
					EselNet.setAction("&clearcompleted=" + hash);
					System.out.println("entferne fertige Datei: " + name + " | Hash: " + hash);
					Gui.runCurrentModule();
				}});
			pop.add(item1);
		} else {
			if (status.equals("Gestoppt")){
				item1 = new JMenuItem("Fortsetzen", new ImageIcon(getClass().getResource("l_resume.gif")));
				item1.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						EselNet.setAction("&op=resume&file=" + hash);
						System.out.println("Fortsetzen der Datei: " + name + " | Hash: " + hash);
						Gui.runCurrentModule();
					}});
			} else {
				item1 = new JMenuItem("Stop", new ImageIcon(getClass().getResource("l_stop.gif")));
				item1.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						EselNet.setAction("&op=stop&file=" + hash);
						System.out.println("Stoppen der Datei: " + name + " | Hash: " + hash);
						Gui.runCurrentModule();
					}});
			}
			if (status.equals("Angehalten")){
				item2 = new JMenuItem("Fortsetzen", new ImageIcon(getClass().getResource("l_resume.gif")));
				item2.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						EselNet.setAction("&op=resume&file=" + hash);
						System.out.println("Fortsetzen der Datei: " + name + " | Hash: " + hash);
						Gui.runCurrentModule();
					}});
			} else {
				item2 = new JMenuItem("Pause", new ImageIcon(getClass().getResource("l_pause.gif")));
				item2.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						EselNet.setAction("&op=pause&file=" + hash);
						System.out.println("Pausieren der Datei: " + name + " | Hash: " + hash);
						Gui.runCurrentModule();
					}});
			}
			item3 = new JMenuItem("Abbruch", new ImageIcon(getClass().getResource("l_cancel.gif")));
			item3.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent arg0) {
					//Sicherheitshinweis bzw. Rckfrage!!!
					askCancel(row2);
				}});
			item4 = new JMenuItem("Umbenennen", new ImageIcon(getClass().getResource("l_rename.gif")));
			item4.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent arg0) {
					renameFile(row2);
				}});
			pop.add(item1);
			pop.add(item2);
			pop.add(item3);
			pop.add(item4);
			if (!comments.equals("is_halfnone.gif")){
				item5 = new JMenuItem("Zeige alle Kommentare...", new ImageIcon(getClass().getResource("l_comments.gif")));
				item5.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						System.out.println("zeige Kommentare der Datei: " + name + " | Hash: " + hash);
						new Kommentare(name, hash);
					}});
				pop.add(item5);
			}
			item9 = new JMenu("Prioritt");
			item9.setIcon(new ImageIcon(getClass().getResource("m_catprio.gif")));
			JCheckBoxMenuItem miLow = new JCheckBoxMenuItem("Niedrig");
			miLow.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent ae) {
					EselNet.setAction("&op=priolow&file=" + hash);
					System.out.println("ndere Prioritt von: " + name +
						"\n   auf: "+ ae.getActionCommand());
					Gui.runCurrentModule();
				}});
			JCheckBoxMenuItem miNormal = new JCheckBoxMenuItem("Normal");
			miNormal.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent ae) {
					EselNet.setAction("&op=prionormal&file=" + hash);
					System.out.println("ndere Prioritt von: " + name +
						"\n   auf: "+ ae.getActionCommand());
					Gui.runCurrentModule();
				}});
			JCheckBoxMenuItem miHigh = new JCheckBoxMenuItem("Hoch");
			miHigh.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent ae) {
					EselNet.setAction("&op=priohigh&file=" + hash);
					System.out.println("ndere Prioritt von: " + name +
						"\n   auf: "+ ae.getActionCommand());
					Gui.runCurrentModule();
				}});
			JCheckBoxMenuItem miAuto = new JCheckBoxMenuItem("Auto");
			miAuto.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent ae) {
					EselNet.setAction("&op=prioauto&file=" + hash);
					System.out.println("ndere Prioritt von: " + name +
						"\n   auf: "+ ae.getActionCommand());
					Gui.runCurrentModule();
				}});
			if (priority.equals("Niedrig"))
				miLow.setSelected(true);
			else if (priority.equals("Normal"))
				miNormal.setSelected(true);
			else if (priority.equals("Hoch"))
				miHigh.setSelected(true);
			else if (priority.contains("Auto"))
				miAuto.setSelected(true);
			item9.add(miLow);
			item9.add(miNormal);
			item9.add(miHigh);
			item9.add(miAuto);
			pop.add(item9);
			item10 = new JMenu("Kategorie");
			item10.setIcon(new ImageIcon(getClass().getResource("m_category.gif")));
			for (int i=0; i<EselMainVis.getCatCount(); i++){
				JCheckBoxMenuItem tmpMI = new JCheckBoxMenuItem(EselMainVis.getCatAt(i));
				tmpMI.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent ae) {
						int catToMove = EselMainVis.getCatItemIndex(ae.getActionCommand());
						if (catToMove>-1){
							EselNet.setAction("&op=setcat&file=" + hash + "&filecat=" + catToMove);
							System.out.println("verschiebe: " + name +
								"\n   in Kategorie: (" + catToMove + ") "+ ae.getActionCommand());
							Gui.runCurrentModule();
						}
					}});
				if (tmpMI.getText().equals(cat))
					tmpMI.setSelected(true);
				else if (i==0 && cat.equals("(Keine Kategorie)"))
					tmpMI.setSelected(true);
				item10.add(tmpMI);
			}
			pop.add(item10);
		}
		item6 = new JMenuItem("Datei Details", new ImageIcon(getClass().getResource("l_info.gif")));
		item6.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				showDetails(row2);
			}});
		item7 = new JMenuItem("ed2k-Link(s)", new ImageIcon(getClass().getResource("l_ed2klink.gif")));
		item7.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				Clipboard cb = Toolkit.getDefaultToolkit().getSystemClipboard();
				cb.setContents(new Transferable(){
					public DataFlavor[] getTransferDataFlavors() {
						DataFlavor[] df = new DataFlavor[1];
						df[0] = DataFlavor.stringFlavor;
						return df;
					}
					public boolean isDataFlavorSupported(DataFlavor arg0) {
						if (arg0==DataFlavor.stringFlavor)
							return true;
						else
							return false;
					}
					public Object getTransferData(DataFlavor arg0) throws UnsupportedFlavorException, IOException {
						return ((DlFile) dlFile.get(translateRowToDlFile(row2))).getEd2k();
					}},
						new ClipboardOwner(){
							public void lostOwnership(Clipboard arg0, Transferable arg1) {
							}
						});
			}});
		pop.add(item6);
		pop.add(item7);
		for (int i=0; i<dataLength; i++)
			if (status.equals("Vollstndig")){
				item8 = new JMenuItem("Fertige Dateien ausblenden", new ImageIcon(getClass().getResource("m_clearcompleted.gif")));
				item8.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						EselNet.setAction("&clearcompleted=all");
						System.out.println("entferne fertige Dateien");
						Gui.runCurrentModule();
					}});
				pop.add(item8);
				break;
			}
		
		return pop;
	}
	
	public int getSortCol() {
		return sortCol;
	}

	public void setSortCol(int col) {
		sortCol = col;
	}
	
	public int getRowCount() {
		return data.length;
	}

	public int getColumnCount() {
		return header.length;
	}

	public Object getValueAt(int row, int col) {
		return data[row][col];
	}
	
	public String getColumnName(int col){
		return header[col];
	}
	
	public synchronized void fireTableDataChanged(){
		getData();
		super.fireTableDataChanged();
	}
	
	//Daten aus der LinkedList der dlFiles in das TableModel bernehmen
	//und ggf. nach Kategorie filtern
	private synchronized void getData(){
		String tmpData[][] = new String[dlFile.size()][header.length+2];
//		data = new String[dlFile.size()][header.length+2];
		int j = 0;
		for (int i=0; i<dlFile.size(); i++){
			//Kategorie-Filter
			if (EselMainVis.getSelCat()!=null && !EselMainVis.getSelCat().equals("") && !EselMainVis.getSelCat().equals("Alle")){
				if (EselMainVis.getSelCatIndex()<EselMainVis.getCatCount()){
					for (;
						j<dlFile.size()
						&& !((DlFile) dlFile.get(j)).getCategory().replace("\\","").equals(EselMainVis.getSelCat());
						j++);
				} else if (EselMainVis.getSelCat().equals("Unkatalogisiert")){
					for (;
						j<dlFile.size()
						&& !((DlFile) dlFile.get(j)).getCategory().replace("\\","").equals("Alle");
						j++);
				} else if (EselMainVis.getSelCat().equals("Unvollstndig")){
					for (;
						j<dlFile.size()
						&& ((DlFile) dlFile.get(j)).getStatus().equals("Vollstndig");
						j++);
				} else if (EselMainVis.getSelCat().equals("Fertiggestellt")){
					for (;
					j<dlFile.size()
					&& !((DlFile) dlFile.get(j)).getStatus().equals("Vollstndig");
					j++);
				} else if (EselMainVis.getSelCat().equals("Warte")){
					for (;
					j<dlFile.size()
					&& !((DlFile) dlFile.get(j)).getStatus().equals("Warte");
					j++);
				} else if (EselMainVis.getSelCat().equals("Ladend")){
					for (;
					j<dlFile.size()
					&& !((DlFile) dlFile.get(j)).getStatus().contains("Herunterladend");
					j++);
				} else if (EselMainVis.getSelCat().equals("Angehalten")){
					for (;
					j<dlFile.size()
					&& !((DlFile) dlFile.get(j)).getStatus().equals("Vollstndig")
					&& !((DlFile) dlFile.get(j)).getStatus().equals("Gestoppt")
					&& !((DlFile) dlFile.get(j)).getStatus().equals("Angehalten");
					j++);
				} else if (EselMainVis.getSelCat().equals("Jemals komplett gesehen")){
					for (;
					j<dlFile.size()
					&& ((DlFile) dlFile.get(j)).getLastFullSeen().equals("Nie");
					j++);
				} else if (EselMainVis.getSelCat().equals("Nie komplett gesehen")){
					for (;
					j<dlFile.size()
					&& !((DlFile) dlFile.get(j)).getLastFullSeen().equals("Nie");
					j++);
				}
			}
			if (j>=dlFile.size())
				break;
			tmpData[i][1] = ((DlFile) dlFile.get(j)).getName();
			tmpData[i][2] = ((DlFile) dlFile.get(j)).getStatus();
			tmpData[i][3] = ((DlFile) dlFile.get(j)).getPriority();
			tmpData[i][4] = ((DlFile) dlFile.get(j)).getSize() + " MB";
			tmpData[i][5] = ((DlFile) dlFile.get(j)).getDownloaded() + " MB";
			tmpData[i][6] = ((DlFile) dlFile.get(j)).getSpeed()!=0.0?((DlFile) dlFile.get(j)).getSpeed() + " kB/s":"";
			tmpData[i][7] = ((DlFile) dlFile.get(j)).getSources()>=0?((DlFile) dlFile.get(j)).getSourcesUsable() + " / " + ((DlFile) dlFile.get(j)).getSources() + " + " + ((DlFile) dlFile.get(j)).getSourcesA4AF():"";
			tmpData[i][8] = ((DlFile) dlFile.get(j)).getCategory().replace("\\","");
			tmpData[i][9] = ((DlFile) dlFile.get(j)).getHash();
			tmpData[i][10] = ((DlFile) dlFile.get(j)).getComment();
			tmpData[i][0] = EselNet.cutDouble((((DlFile) dlFile.get(j)).getDownloaded()/((DlFile) dlFile.get(j)).getSize())*100) + "%";
			j++;
		}
		int i;
		//Neues TabellenModell ohne leere Zeilen am Schluss
		for (i=0; i<tmpData.length; i++)
			if (tmpData[i][1]==null)
				break;
		String[][] tmpData2 = new String[i][header.length+2];
		for (i=0; i<tmpData2.length; i++)
			tmpData2[i]=tmpData[i];
		data = tmpData2;
		sortData();
	}
	
	//inv=true, wenn ein zweites mal auf den selben Spaltenkopf geklickt wurde.
	//Dann wird die Spalte invertiert sortiert.
	public synchronized void toggleInv(){
		inv = inv?false:true;
	}
	
	//Sortier-Algorythmus:
	//Spalten mit Double-Werten werden nicht alphabetisch, sondern nach ihren Werten sortiert.
	public synchronized void sortData(){
		if (data.length < 1 || data[0][0] == null)
			return;
		String[] tmpRow = new String[header.length+2];
		if (sortCol==0 || sortCol==4 || sortCol==5 || sortCol==6){
			for (int i=data.length; i>0; i--){
				for (int j=0; j<i-1; j++){
					if (!inv){
						if ((data[j][sortCol].equals("") && !data[j+1][sortCol].equals("")) || (!data[j+1][sortCol].equals("") && Double.parseDouble(data[j][sortCol].replace("MB", "").replace("/s", "").replace("%", ""))<Double.parseDouble(data[j+1][sortCol].replace("MB", "").replace("/s", "").replace("%", "")))){
//							System.out.println(data[j][sortCol]);
							tmpRow = data[j+1];
							data[j+1] = data[j];
							data[j] = tmpRow;
						}
					} else {
						if (data[j+1][sortCol].equals("") || (!data[j][sortCol].equals("") && Double.parseDouble(data[j][sortCol].replace("MB", "").replace("/s", "").replace("%", ""))>Double.parseDouble(data[j+1][sortCol].replace("MB", "").replace("/s", "").replace("%", "")))){
							tmpRow = data[j+1];
							data[j+1] = data[j];
							data[j] = tmpRow;
						}
					}
				}
			}
		} else if (sortCol==7){
			for (int i=data.length; i>0; i--){
				for (int j=0; j<i-1; j++){
					if (!inv){
						if ((data[j][sortCol].equals("") && !data[j+1][sortCol].equals("")) || (!data[j+1][sortCol].equals("") && Integer.parseInt(data[j][sortCol].substring(data[j][sortCol].indexOf("/")+2, data[j][sortCol].length()))
								<Integer.parseInt(data[j+1][sortCol].substring(data[j+1][sortCol].indexOf("/")+2, data[j+1][sortCol].length())))){
							tmpRow = data[j+1];
							data[j+1] = data[j];
							data[j] = tmpRow;
						}
					} else  {
						if (data[j+1][sortCol].equals("") || (!data[j][sortCol].equals("") && Integer.parseInt(data[j][sortCol].substring(data[j][sortCol].indexOf("/")+2, data[j][sortCol].length()))
								>Integer.parseInt(data[j+1][sortCol].substring(data[j+1][sortCol].indexOf("/")+2, data[j+1][sortCol].length())))){
							tmpRow = data[j+1];
							data[j+1] = data[j];
							data[j] = tmpRow;
						}
					}
				}
			}
		} else {
			for (int i=data.length; i>0; i--){
				for (int j=0; j<i-1; j++){
					if (!inv){
						if (data[j][sortCol].compareToIgnoreCase(data[j+1][sortCol])>0){
							tmpRow = data[j+1];
							data[j+1] = data[j];
							data[j] = tmpRow;
						}
					} else {
						if (data[j][sortCol].compareToIgnoreCase(data[j+1][sortCol])<0){
							tmpRow = data[j+1];
							data[j+1] = data[j];
							data[j] = tmpRow;
						}
					}
				}
			}
		}
	}
	
	public void askCancel(int row) {
		final int row2 = row;
		//Sicherheitshinweis bzw. Rckfrage!!!
		new JDialog(){
			private static final long serialVersionUID = 1L;
			{
				setModal(true);
				setAlwaysOnTop(true);
				setSize(500, 120);
				setResizable(false);
				Point center = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint();
				setLocation(new Double(center.getX()).intValue()-250, new Double(center.getY()).intValue()-60);
				setTitle("Abbruch");
				setLayout(new BorderLayout());
				JLabel msg = new JLabel("<html><div align=\"center\">Soll die Datei wirklich abgebrochen und gelscht werden?<br>" + data[row2][1]);
				msg.setHorizontalAlignment(JLabel.CENTER);
				add(msg, BorderLayout.CENTER);
				JPanel btnPanel = new JPanel();
				btnPanel.setLayout(new BorderLayout());
				JButton btOK = new JButton("Ja");
				btOK.setPreferredSize(new Dimension(247, 25));
				btOK.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						EselNet.setAction("&op=cancel&file=" + data[row2][9]);
						System.out.println("Abbrechen der Datei: " + data[row2][1] + " | Hash: " + data[row2][9]);
						setVisible(false);
						Gui.runCurrentModule();
					}});
				btnPanel.add(btOK, BorderLayout.WEST);
				JButton btCancel = new JButton("Nein");
				btCancel.setPreferredSize(new Dimension(247, 25));
				btCancel.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						setVisible(false);
					}});
				btnPanel.add(btCancel, BorderLayout.EAST);
				add(btnPanel, BorderLayout.SOUTH);
				addWindowListener(new WindowListener(){
					public void windowOpened(WindowEvent arg0) {
					}
					public void windowClosing(WindowEvent arg0) {
					}
					public void windowClosed(WindowEvent arg0) {
						setVisible(false);
					}
					public void windowIconified(WindowEvent arg0) {
					}
					public void windowDeiconified(WindowEvent arg0) {
					}
					public void windowActivated(WindowEvent arg0) {
					}
					public void windowDeactivated(WindowEvent arg0) {
					}});
				setVisible(true);
			}
		};
	}
	
	public synchronized void renameFile(int row) {
		final int row2 = row;
		try {
			new JDialog(){
				private static final long serialVersionUID = 1L;
				{
					setModal(true);
					setAlwaysOnTop(true);
					setSize(500, 100);
					setResizable(false);
					Point center = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint();
					setLocation(new Double(center.getX()).intValue()-250, new Double(center.getY()).intValue()-50);
					setTitle("Umbenennen");
					setLayout(new BorderLayout());
					JLabel lbName = new JLabel("Neuer Name:");
					add(lbName, BorderLayout.NORTH);
					final TextField tfName = new TextField(data[row2][1].replace("<html>", "").replace("</html>", ""));
					tfName.setPreferredSize(new Dimension(494, 25));
					add(tfName, BorderLayout.CENTER);
					JPanel btnPanel = new JPanel();
					btnPanel.setLayout(new BorderLayout());
					JButton btOK = new JButton("OK");
					btOK.setPreferredSize(new Dimension(247, 25));
					btOK.addActionListener(new ActionListener(){
						public void actionPerformed(ActionEvent arg0) {
							try {
								EselNet.setAction("&op=rename&name=" + URLEncoder.encode(tfName.getText(), "UTF-8") + "&file=" + data[row2][9]);
								System.out.println("Umbenennen der Datei: " + data[row2][1] + " | Hash: " + data[row2][9] + 
										"\n     in: " + tfName.getText());
							} catch (UnsupportedEncodingException e) {
								System.out.println("Umbenennen fehlgeschlagen: " + e);
							}
							setVisible(false);
							Gui.runCurrentModule();
						}});
					btnPanel.add(btOK, BorderLayout.WEST);
					JButton btCancel = new JButton("Abbrechen");
					btCancel.setPreferredSize(new Dimension(247, 25));
					btCancel.addActionListener(new ActionListener(){
						public void actionPerformed(ActionEvent arg0) {
							setVisible(false);
						}});
					btnPanel.add(btCancel, BorderLayout.EAST);
					add(btnPanel, BorderLayout.SOUTH);
					addWindowListener(new WindowListener(){
						public void windowOpened(WindowEvent arg0) {
						}
						public void windowClosing(WindowEvent arg0) {
						}
						public void windowClosed(WindowEvent arg0) {
							setVisible(false);
						}
						public void windowIconified(WindowEvent arg0) {
						}
						public void windowDeiconified(WindowEvent arg0) {
						}
						public void windowActivated(WindowEvent arg0) {
						}
						public void windowDeactivated(WindowEvent arg0) {
						}});
					setVisible(true);
				}
			};
		} catch (HeadlessException e) {
			e.printStackTrace();
		}
	}
	
	public void showDetails(int row) {
		final int row2 = row;
		new JDialog(){
			private static final long serialVersionUID = 1L;
			{
				setModal(true);
				setAlwaysOnTop(true);
				setSize(500, 320);
				Point center = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint();
				setLocation(new Double(center.getX()).intValue()-250, new Double(center.getY()).intValue()-160);
				setTitle("Datei Details");
				setLayout(new GridLayout(11, 1));
				int row = translateRowToDlFile(row2);
				JLabel lbName = new JLabel("<html>Dateiname: " + ((DlFile) dlFile.get(row)).getName().replace("<html>", ""));
				add(lbName);
				JLabel lbHash = new JLabel("Hash: " + ((DlFile) dlFile.get(row)).getHash());
				add(lbHash);
				JLabel lbSize = new JLabel("Dateigre: " + data[row2][4] + " (Gre auf Disk: " + ((DlFile) dlFile.get(row)).getSizeOnDisk() + ")");
				add(lbSize);
				JLabel lbMet = new JLabel("met-Datei: " + ((DlFile) dlFile.get(row)).getMet());
				add(lbMet);
				JLabel lbStatus = new JLabel("Status: " + data[row2][2]);
				add(lbStatus);
				JLabel lbFertig = new JLabel("Fertiggestellt: " + data[row2][5] + "/" + data[row2][4] + " (" + data[row2][0] + ")");
				add(lbFertig);
				JLabel lbQuellen = new JLabel("Quellen: " + (((DlFile) dlFile.get(row)).getSourcesUsable() + ((DlFile) dlFile.get(row)).getSourcesNNP()) + " (ntzlich: " + ((DlFile) dlFile.get(row)).getSourcesUsable() + ", NNP: " + ((DlFile) dlFile.get(row)).getSourcesNNP() + ", A4AF: " + ((DlFile) dlFile.get(row)).getSourcesA4AF() + ")");
				add(lbQuellen);
				JLabel lbParts = new JLabel("Dateiteile: " + ((DlFile) dlFile.get(row)).getFileParts() + ", verfgbar: " + ((DlFile) dlFile.get(row)).getAvailableFileParts() + " (" + (((DlFile) dlFile.get(row)).getAvailableFileParts()/((DlFile) dlFile.get(row)).getFileParts()*100) + "%)");
				add(lbParts);
				JLabel lbKompl = new JLabel("Zuletzt Komplett entdeckt: " + ((DlFile) dlFile.get(row)).getLastFullSeen());
				add(lbKompl);
				JLabel lbLastRec = new JLabel("Letzter Empfang: " + ((DlFile) dlFile.get(row)).getLastDl());
				add(lbLastRec);
				JButton btClose = new JButton("OK");
				btClose.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						setVisible(false);
					}});
				add(btClose);
				addWindowListener(new WindowListener(){
					public void windowOpened(WindowEvent arg0) {
					}
					public void windowClosing(WindowEvent arg0) {
					}
					public void windowClosed(WindowEvent arg0) {
						setVisible(false);
					}
					public void windowIconified(WindowEvent arg0) {
					}
					public void windowDeiconified(WindowEvent arg0) {
					}
					public void windowActivated(WindowEvent arg0) {
					}
					public void windowDeactivated(WindowEvent arg0) {
					}});
				setVisible(true);
			}
		};
	}
	
	private int translateRowToDlFile(int row){
		int i = 0;
		for (i=0; i<dlFile.size() && !((DlFile) dlFile.get(i)).getHash().equals(data[row][9]); i++);
		return i;
	}
	
}
