package remoteSystem;

import java.awt.Toolkit;
import java.awt.datatransfer.*;
import java.io.File;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import javax.swing.ImageIcon;

public class Ed2k extends EselNet{

	private static final long serialVersionUID = 1L;

	private static Clipboard cb = Toolkit.getDefaultToolkit().getSystemClipboard();
	private static String link = "";
	private static Ed2k this2;
	private static File f1 = new File("snd1.wav");
	private static File f2 = new File("snd2.wav");
	private static StrippedSound snd1 = new StrippedSound(f1);
	private static StrippedSound snd2 = new StrippedSound(f2);
	
	public Ed2k(){
		this2 = this;
		clearCB();
		//FlavourListener, um nderungen in der Zwischenablage zu merken
		cb.addFlavorListener(new FlavorListener(){
			public void flavorsChanged(FlavorEvent fe) {
				try {
					if (cb.isDataFlavorAvailable(DataFlavor.stringFlavor)){
						link = cb.getData(DataFlavor.stringFlavor).toString();
						if (link.startsWith("*EselRemoteTrigger*ed2k://")){
							link = link.replace("*EselRemoteTrigger*", "");
							Thread t = new Thread(this2);
							t.setPriority(1);
							t.start();
						}
					}
				} catch (UnsupportedFlavorException e) {
					System.out.println("kein String: " + e);
				} catch (IOException e) {
					System.out.println("Zugriff auf Zwischenablage nicht mglich: " + e);
				}catch (IllegalStateException e) {
					System.out.println("Zugriff auf Zwischenablage nicht mglich: " + e);
				}
			}});
	}

	//ClipBoard lschen - echt kompliziert...
	private synchronized void clearCB(){
		cb.setContents(new Transferable(){
			public DataFlavor[] getTransferDataFlavors() {
				DataFlavor[] df = new DataFlavor[1];
				df[0] = DataFlavor.imageFlavor;
				return df;
			}
			public boolean isDataFlavorSupported(DataFlavor arg0) {
				if (arg0==DataFlavor.imageFlavor)
					return true;
				else
					return false;
			}
			public Object getTransferData(DataFlavor arg0) throws UnsupportedFlavorException, IOException {
				return null;
			}},
				new ClipboardOwner(){
					public void lostOwnership(Clipboard arg0, Transferable arg1) {
					}
				});
	}
	
	public void run() {
		while (running){
			try {
				Thread.sleep(100);
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}
		}
		if (!connected){
			System.out.println("___keine_Verbindung___");
			if (Gui.isSoundOn())
				snd2.play();
			return;
		}
		running = true;
		if (sesID!=0){
			try {
				//Link an eMule senden
				Gui.getTrayIcon().setIcon(new ImageIcon(getClass().getResource("h_server_a3.gif")));
				setAction("?ses=" + sesID + "&w=transfer&ed2k="	+ URLEncoder.encode(link, "UTF-8") + "&cat=" + (EselMainVis.getSelCatIndex()<EselMainVis.getCatCount()?EselMainVis.getSelCatIndex()+"":"0"));
				System.out.println("bermittle: " + link + "\nzur Kategorie: (" + EselMainVis.getSelCatIndex() + ") " + EselMainVis.getSelCat());
				link = "";
				clearCB();
				transAction(true, Thread.currentThread().getId());
				Gui.getTrayIcon().setIcon(new ImageIcon(getClass().getResource("h_server.gif")));
				if (Gui.isSoundOn())
					snd1.play();
				Gui.runCurrentModule();
				releaseSb(Thread.currentThread().getId());
			} catch (UnsupportedEncodingException e) {
				System.out.println("Codierungsfehler: " + e);
				releaseSb(Thread.currentThread().getId());
				Gui.getTrayIcon().setIcon(new ImageIcon(getClass().getResource("h_server.gif")));
				if (Gui.isSoundOn())
					snd2.play();
			}
		} else {
			if (Gui.isSoundOn())
				snd2.play();
		}
		running = false;
	}
	
	protected synchronized void disconnectModule(int type){
		if (type==0)
			System.out.println("(manuelle Trennung)");
		else
			System.out.println("(Trennung durch " + this.getClass().getSimpleName() + ")");
		super.disconnect(type);
	}

	protected void reset() {
	}

}
