package remoteSystem;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.LinkedList;
import java.util.prefs.Preferences;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SpringLayout;

public class EselMainVis extends JPanel{
	
	private static final long serialVersionUID = 1L;
	
	private static JButton btConn = new JButton("");
	private static JLabel server = new JLabel("Nicht verbunden    (");
	private static JLabel user = new JLabel("0");
	private static JLabel maxUser = new JLabel("(0)");
	private static JLabel files = new JLabel("0 )");
	private static JLabel kadConn = new JLabel("Nicht verbunden");
	private static JLabel dlSpeed = new JLabel("Download: 0.0");
	private static JLabel dlSL = new JLabel("(0)");
	private static JLabel ulSpeed = new JLabel("Upload: 0.0");
	private static JLabel ulSL = new JLabel("(0)");
	private static JLabel conns = new JLabel("0");
	private static JLabel maxConns = new JLabel("(0)");
	private static JComboBox cat = new JComboBox();
	private static boolean creating = true;
	private static int catCount = 0;
	private static boolean admin = false;
	
	public EselMainVis(){
		btConn.setText("Connect");
		this.setPreferredSize(new Dimension(1274, 70));
		btConn.setIcon(new ImageIcon(getClass().getResource("l_connect.gif")));
		btConn.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				if (btConn.getText()=="Disconnect"){
					Gui.manDisconnect();
				} else if (btConn.getText()=="Connect"){
					Gui.manConnect(false);
				}
			}});
		
		SpringLayout lay1 = new SpringLayout();
		this.setLayout(lay1);
		
		//ImageIcons
		server.setIcon(new ImageIcon(getClass().getResource("high.gif")));
		user.setIcon(new ImageIcon(getClass().getResource("l_users.gif")));
		files.setIcon(new ImageIcon(getClass().getResource("filetype_other.gif")));
		kadConn.setIcon(new ImageIcon(getClass().getResource("h_kad.gif")));
		dlSpeed.setIcon(new ImageIcon(getClass().getResource("arrow_down.gif")));
		ulSpeed.setIcon(new ImageIcon(getClass().getResource("arrow_up.gif")));
		conns.setIcon(new ImageIcon(getClass().getResource("l_con.gif")));
		this.add(server);
		this.add(user);
		this.add(maxUser);
		this.add(files);
		this.add(kadConn);
		this.add(dlSpeed);
		this.add(dlSL);
		this.add(ulSpeed);
		this.add(ulSL);
		this.add(conns);
		this.add(maxConns);
		this.add(cat);
		this.add(btConn);
		
		//SpringLayout-Constraints
		lay1.putConstraint(SpringLayout.WEST, server, 3, SpringLayout.WEST, this);
		lay1.putConstraint(SpringLayout.NORTH, server, 5, SpringLayout.NORTH, this);
		lay1.putConstraint(SpringLayout.WEST, user, 2, SpringLayout.EAST, server);
		lay1.putConstraint(SpringLayout.NORTH, user, 5, SpringLayout.NORTH, this);
		lay1.putConstraint(SpringLayout.WEST, maxUser, 5, SpringLayout.EAST, user);
		lay1.putConstraint(SpringLayout.NORTH, maxUser, 5, SpringLayout.NORTH, this);
		lay1.putConstraint(SpringLayout.WEST, files, 10, SpringLayout.EAST, maxUser);
		lay1.putConstraint(SpringLayout.NORTH, files, 5, SpringLayout.NORTH, this);
		lay1.putConstraint(SpringLayout.WEST, kadConn, 50, SpringLayout.EAST, files);
		lay1.putConstraint(SpringLayout.NORTH, kadConn, 5, SpringLayout.NORTH, this);
		lay1.putConstraint(SpringLayout.EAST, btConn, -3, SpringLayout.EAST, this);
		lay1.putConstraint(SpringLayout.NORTH, btConn, 5, SpringLayout.NORTH, this);
		lay1.putConstraint(SpringLayout.WEST, dlSpeed, 3, SpringLayout.WEST, this);
		lay1.putConstraint(SpringLayout.NORTH, dlSpeed, 3, SpringLayout.SOUTH, btConn);
		lay1.putConstraint(SpringLayout.WEST, dlSL, 5, SpringLayout.EAST, dlSpeed);
		lay1.putConstraint(SpringLayout.NORTH, dlSL	, 3, SpringLayout.SOUTH, btConn);
		lay1.putConstraint(SpringLayout.WEST, ulSpeed, 30, SpringLayout.EAST, dlSL);
		lay1.putConstraint(SpringLayout.NORTH, ulSpeed, 3, SpringLayout.SOUTH, btConn);
		lay1.putConstraint(SpringLayout.WEST, ulSL, 5, SpringLayout.EAST, ulSpeed);
		lay1.putConstraint(SpringLayout.NORTH, ulSL, 3, SpringLayout.SOUTH, btConn);
		lay1.putConstraint(SpringLayout.WEST, conns, 50, SpringLayout.EAST, ulSL);
		lay1.putConstraint(SpringLayout.NORTH, conns, 3, SpringLayout.SOUTH, btConn);
		lay1.putConstraint(SpringLayout.WEST, maxConns, 5, SpringLayout.EAST, conns);
		lay1.putConstraint(SpringLayout.NORTH, maxConns, 3, SpringLayout.SOUTH, btConn);
		lay1.putConstraint(SpringLayout.EAST, cat, -3, SpringLayout.EAST, this);
		lay1.putConstraint(SpringLayout.NORTH, cat, 3, SpringLayout.SOUTH, btConn);
		
		//Anpassen des aktuellen Tab-Views an die Kategorie-auswahl
		//und merken der Kategorie in der Registry
		cat.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent arg0) {
				if (cat.getItemCount()>0 && creating==false){
					Preferences prefs = Preferences.userRoot().node("/EselRemote/Options");
					prefs.put("lastcat", (String) cat.getSelectedItem());
					Gui.updateModules();
				}
			}});
	}

	//Button in Connect-Status und zurck
	public static void setConnButton(boolean connecting, boolean auto){
		if (connecting){
			if (auto)
				btConn.setText("Auto-Connecting...");
			else
				btConn.setText("Connecting...");
			btConn.setEnabled(false);
		} else {
			if (EselNet.connected){
				btConn.setText("Disconnect");
				btConn.setEnabled(true);
			} else {
				btConn.setText("Connect");
				btConn.setEnabled(true);
			}
		}
	}
	
	//Teil des Parsens der html-Antwort des eMule-WebServers,
	//der immer gleich ist, und deshalb gesondert behandert wird.
	protected static synchronized int parseHeader(StringBuffer sb){
		int i = 0;
		int n = 0;
		admin = false;
		if (sb.indexOf(String.valueOf(EselNet.sesID))!=-1 && EselNet.sesID!=0){
			System.out.println("..... parse Header .....");
			for (i=0; i<sb.length() && i!=-1; n++){
				int end = sb.indexOf("\n", i+1)==-1?sb.length():sb.indexOf("\n", i+1);
				String tmpStr = sb.substring(i, end);
				i = end;
				if (tmpStr.contains("&w=server&c=disconnect")){
					setServer(tmpStr.substring(tmpStr.indexOf("align=\"left\">")+14, tmpStr.indexOf("(")-1));
					setFiles(tmpStr.substring(tmpStr.indexOf("<img src=\"filetype_other.gif\" align=\"middle\">")+46, tmpStr.indexOf(")</td>")));
				}
				if (tmpStr.contains("<img src=\"h_kad.gif\" width=\"16\" height=\"16\" align=\"left\">")){
					setKadConn(tmpStr.substring(tmpStr.indexOf("<img src=\"h_kad.gif\" width=\"16\" height=\"16\" align=\"left\">")+58, tmpStr.indexOf("(")-1).equals("Verbunden")?true:false);
				}
				if (tmpStr.contains("<img src=\"arrow_down.gif\" align=\"left\" hspace=\"3\" vspace=\"4\"> Download:")){
					setDlSpeed(Double.parseDouble(tmpStr.substring(tmpStr.indexOf("Download:")+10, tmpStr.indexOf("(")-1)));
					String tmpDlSL = tmpStr.substring(tmpStr.indexOf("(")+1, tmpStr.indexOf(")"));
					if (!tmpDlSL.equals("Unbegrenzt"))
						setDlSL(Double.parseDouble(tmpDlSL));
					else
						setDlSL(0);
				}
				if (tmpStr.contains("<img src=\"arrow_up.gif\" align=\"left\" hspace=\"3\" vspace=\"4\"> Upload:")){
					setUlSpeed(Double.parseDouble(tmpStr.substring(tmpStr.indexOf("Upload:")+8, tmpStr.indexOf("(")-1)));
					String tmpUlSL = tmpStr.substring(tmpStr.indexOf("(")+1, tmpStr.indexOf(")"));
					if (!tmpUlSL.equals("Unbegrenzt"))
						setUlSL(Double.parseDouble(tmpUlSL));
					else
						setUlSL(0);
				}
				if (tmpStr.contains("<img src=\"l_con.gif\" align=\"left\" hspace=\"3\" vspace=\"4\"> Aktive Verbindungen:")){
					setConns(Integer.parseInt(tmpStr.substring(tmpStr.indexOf("Verbindungen:")+14, tmpStr.indexOf("(")-1)));
					setMaxConns(Integer.parseInt(tmpStr.substring(tmpStr.indexOf("(")+1, tmpStr.indexOf(")"))));
				}
				if (tmpStr.contains("<img src=\"l_users.gif\" align=\"left\" hspace=\"3\" vspace=\"4\"> Benutzer:")){
					setUser(tmpStr.substring(tmpStr.indexOf("Benutzer:")+10, tmpStr.indexOf("(")-1));
					setMaxUser(tmpStr.substring(tmpStr.indexOf("(")+1, tmpStr.indexOf(")")));
				}
				if (tmpStr.contains("adminmenu(event,'admin')")){
					admin = true;
				}
				if (tmpStr.contains("<option ")){
					LinkedList tmpCatList = new LinkedList();
					while (tmpStr.contains("<option ") && i<sb.length() && i!=-1){
						int a = tmpStr.indexOf("<option ");
						int b = tmpStr.indexOf(">", a)+1;
						int c = tmpStr.indexOf("<", b);
						tmpCatList.add(tmpStr.substring(b, c));
						end = sb.indexOf("\n", i+1)==-1?sb.length():sb.indexOf("\n", i+1);
						tmpStr = sb.substring(i, end);
						i = end;
					}
					setCat(tmpCatList);
					Gui.setAdmin(admin);
					return i;
				}
			}
		}
		return i;
	}
	
	public static synchronized void disconnect(){
		setServer("Nicht verbunden");
		setFiles("0");
		setKadConn(false);
		setDlSpeed(0.0);
		setDlSL(0);
		setUlSpeed(0.0);
		setUlSL(0);
		setConns(0);
		setMaxConns(0);
		setUser("0");
		setMaxUser("0");
		cat.removeAllItems();
		catCount = 0;
		admin = false;
		btConn.setText("Connect");
		btConn.setEnabled(true);
	}
	
	//setzen der Kategorie-Items fr die ComboBox
	//und setzen der zuletzt gewhlten Kategotie
	public static synchronized void setCat(LinkedList cat1){
		//berprfen ob nderung notwendig
		boolean newCat = false;
		for (int i=0; i<catCount && i<cat1.size(); i++){
			if (!cat.getItemAt(i).equals(cat1.get(i))){
				newCat = true;
				break;
			}
		}
		if (catCount!=cat1.size())
			newCat=true;
		if (!newCat && cat.getItemCount()!=0)
			return;
		//Neue kategorieComboBox erstellen
		creating = true;
		cat.removeAllItems();
		for (int i=0; i<cat1.size(); i++)
			cat.addItem((String) cat1.get(i));
		if (cat1.size()==0)
			cat.addItem("Alle");
		if (cat1.size()>0)
			((String) cat.getItemAt(0)).replace(((String) cat.getItemAt(0)), "Alle");
		cat.addItem("-------------------------------------");
		cat.addItem("Unkatalogisiert");
		cat.addItem("Unvollstndig");
		cat.addItem("Fertiggestellt");
		cat.addItem("Warte");
		cat.addItem("Ladend");
		cat.addItem("Angehalten");
		cat.addItem("Jemals komplett gesehen");
		cat.addItem("Nie komplett gesehen");
		Preferences prefs = Preferences.userRoot().node("/EselRemote/Options");
		String tmpCat = prefs.get("lastcat", "Alle");
		for (int i=0; i<cat.getItemCount(); i++){
			if (cat.getItemAt(i).equals(tmpCat)){
				cat.setSelectedIndex(i);
				break;
			}
		}
		catCount = cat1.size();
		creating = false;
	}
	
	public static String getSelCat(){
		return (String) cat.getSelectedItem();
	}
	
	public static JComboBox getCombCat(){
		return cat;
	}
	
	public static int getCatCount(){
		return catCount;
	}
	
	public static String getCatAt(int i){
		return (String) cat.getItemAt(i);
	}
	
	public static int getCatItemIndex(String catName){
		int i=0;
		for (; i<cat.getItemCount(); i++)
			if (cat.getItemAt(i).equals(catName))
				break;
		return i>=cat.getItemCount()?-1:i;
	}
	
	public static int getSelCatIndex(){
		return cat.getSelectedIndex();
	}

	public static void setConns(int conns1) {
		conns.setText("" + conns1);
	}

	public static void setDlSL(double dlSL1) {
		String dlSlString = new Double(dlSL1).intValue() + "";
		if (dlSL1==0 && EselNet.connected)
			dlSlString = "Unbegrenzt";
		dlSL.setText("(" + dlSlString + ")");
	}

	public static void setDlSpeed(double dlSpeed1) {
		dlSpeed.setText("Download: "+ dlSpeed1);
	}

	public static void setFiles(String files1) {
		files.setText(files1 + " )");
	}
	
	public static void setKadConn(boolean kadConn1) {
		kadConn.setText("" + (kadConn1?"Verbunden":"Nicht verbunden"));
	}

	public static void setMaxConns(int maxConns1) {
		maxConns.setText("(" + maxConns1 + ")");
	}

	public static void setMaxUser(String maxUser1) {
		maxUser.setText("(" + maxUser1 + ")");
	}
	
	public static void setServer(String server1) {
		server.setText(server1 + "    (");
	}

	public static void setUlSL(double ulSL1) {
		String ulSlString = new Double(ulSL1).intValue() + "";
		if (ulSL1==0 && EselNet.connected)
			ulSlString = "Unbegrenzt";
		ulSL.setText("(" + ulSlString + ")");
	}

	public static void setUlSpeed(double ulSpeed1) {
		ulSpeed.setText("Upload: " + ulSpeed1);
	}
	
	public static void setUser(String user1) {
		user.setText(user1);
	}
	
}
