package remoteSystem;

import java.io.*;
import java.net.*;
import java.util.LinkedList;
import java.util.zip.GZIPInputStream;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import org.jdesktop.jdic.tray.TrayIcon;

public abstract class EselNet extends JPanel implements Runnable{

	private static final long serialVersionUID = 1L;
	
	protected static String host, password;
	protected static URL eselURL;
	protected static boolean running = false;
	protected static boolean connected = false;
	protected static int port, sesID = 0;
	protected static StringBuffer connSb = new StringBuffer();
	protected static LinkedList sbList = new LinkedList();
	protected static LinkedList urlList = new LinkedList();
	protected static LinkedList inUse = new LinkedList();
	
	public static synchronized void setMule(String host1, int port1, String password1){
		host = host1;
		port = port1;
		password = password1;
	}
	
	//Verbindung mit dem Esel herstellen
	//Passwort senden und Session-ID auslesen
	public static synchronized void connect(){
		System.out.println("Verbinde mit   http://" + host + ":" + port);
		setAction("?p=" + password + "&w=password");
		try {
			Reader is = new InputStreamReader(eselURL.openStream());
			BufferedReader in = new BufferedReader(is);
			connSb.delete(0,connSb.length());
			for (String s; (s = in.readLine()) != null;){
				connSb.append(s);
				connSb.append("\n");
				if (s.contains("location.href = \"/?ses=") || s.contains("location.href = \"?ses=")){
					sesID = Integer.parseInt(s.substring(s.indexOf("ses=")+4, s.indexOf("&")));
					System.out.println("   - SessionID: " + sesID);
					break;
				}
			}
			in.close();
			if (sesID!=0){
				connected = true;
				Gui.globalConnect();
			}
		} catch (IOException e) {
			System.out.println("Verbindungsfehler: " + e);
			disconnect(2);
		}
	}
	
	//Neue Informationen werden ber eine neue http-Anfrage angefordert.
	//Diese Anfrage wird hier formuliert
	public static synchronized void setAction(String urlFile){
		try {
			eselURL = new URL("http", host, port, "/" + urlFile);
		} catch (MalformedURLException e) {
			System.out.println("URL-Fehler: " + e);
			disconnect(1);
		}
	}

	//Die Anfrage (s.o. --> setAction(String urlFile)) wird gestellt
	//GZIP-Komprimierung wird gegebenenfalls behandelt
	public static synchronized void transAction(boolean justSend, long owner){
		if (sesID!=0){
			if (!eselURL.toString().contains("ed2k=ed2k")){
				try {
					Gui.getTrayIcon().setIcon(new ImageIcon(Class.forName("remoteSystem.Gui").getResource("h_server_busy.gif")));
				} catch (ClassNotFoundException e) {
					System.out.println("Klasse nicht gefunden");
				}
			}
			System.out.println("..... Datenbertragung .....");
			try {
				boolean isgzip = true;
				InputStream gzip = null;
				BufferedReader in;
				try {
					gzip = new GZIPInputStream(eselURL.openStream());
				} catch (IOException e){
					isgzip = false;
				}
				if (isgzip){
					Reader gzipReader = new InputStreamReader(gzip);
					in = new BufferedReader(gzipReader);
				} else {
					Reader is = new InputStreamReader(eselURL.openStream());
					in = new BufferedReader(is);
				}
				if (!justSend){
					StringBuffer tmpSb = null;
					int i=0;
					for (; i< sbList.size(); i++){
						if (((Long) inUse.get(i)).equals(new Long(0))){
							tmpSb = (StringBuffer) sbList.get(i);
							break;
						}
					}
					if (tmpSb==null){
						tmpSb = new StringBuffer();
						sbList.add(tmpSb);
						inUse.add(new Long(owner));
					} else {
						inUse.set(i, new Long(owner));
					}
					tmpSb.delete(0, tmpSb.length());
					for (String s; (s = in.readLine()) != null;){
						tmpSb.append(s);
						tmpSb.append("\n");
					}
				}
				in.close();
			} catch (IOException e) {
				System.out.println("Fehler bei Datenbertragung: " + e);
				disconnect(1);
			}
			if (connected && !eselURL.toString().contains("ed2k=ed2k")){
				try {
					Gui.getTrayIcon().setIcon(new ImageIcon(Class.forName("remoteSystem.Gui").getResource("h_server.gif")));
				} catch (ClassNotFoundException e) {
					System.out.println("Klasse nicht gefunden");
				}
			}
		}
		System.gc();
	}
	
	protected abstract void disconnectModule(int type); 
	
	protected abstract void reset();
	
	protected static synchronized void disconnect(int type){
		sesID = 0;
		EselMainVis.disconnect();
		System.out.println("Verbindung zu eMule verloren!");
		if (type==1)
			Gui.getTrayIcon().displayMessage("Verbindung unterbrochen", "Die Verbindung zu " + host + " wurde unterbrochen.", TrayIcon.WARNING_MESSAGE_TYPE);
		if (type==2)
			Gui.getTrayIcon().displayMessage("Verbindungsfehler", "Die Verbindung zu " + host + " konnte nicht hergestellt werden.", TrayIcon.WARNING_MESSAGE_TYPE);
		connected = false;
		Gui.globalDisconnect();
	}
	
	//Rundet einen Double-Wert auf zwei Stellen nach dem Komma , falls er lnger ist
	protected static double cutDouble(double d){
		String ds = d+"";
		if (!ds.equals("NaN") && ds.substring(ds.indexOf("."), ds.length()).length()>3){
			int rndVal = ds.charAt(ds.indexOf(".")+3);
			if (rndVal>=5)
				ds = (d+0.01)+"";
			d = Double.parseDouble(ds.substring(0, ds.indexOf(".")+3));
		}
		return d;
	}
	
	public static synchronized String getHost(){
		return eselURL.getHost();
	}
	
	protected synchronized void releaseSb(long owner){
		for (int i=0; i<inUse.size(); i++){
			if (((Long) inUse.get(i)).equals(new Long(owner)))
				inUse.set(i, new Long(0));
		}
	}
	
	protected static synchronized StringBuffer getMySB(long owner) throws StringBufferNotFoundExeption{
		for (int i=0; i<inUse.size(); i++){
			if (((Long) inUse.get(i)).equals(new Long(owner)))
				return (StringBuffer) sbList.get(i);
		}
		throw Gui.getSelectedModule().new StringBufferNotFoundExeption("Kein StringBuffer fr " + owner + " vorhanden.");
	}
	
	public class StringBufferNotFoundExeption extends Throwable{
		
		private static final long serialVersionUID = 1L;

		public StringBufferNotFoundExeption(String s){
			super(s);
		}
		
	}
	
}
