package remoteSystem;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GraphicsEnvironment;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class EselOpt extends EselNet{

	private static final long serialVersionUID = 1L;
	private static EselNet this2;
	private static boolean read = false;
	private boolean vis = false;
	private static String gzip;
	private static int maxcapdown, maxcapup, maxdown, maxup, maxsources, maxconnections, maxconnectionsperfive;
	private static JCheckBox gzipCheck = new JCheckBox("GZIP-Komprimierung");
	private static JTextField dlBWText, ulBWText, dlLimText, ulLimText, maxSrcText, maxConnText, maxConnPer5Text;

	protected synchronized void disconnectModule(int type){
		if (type==0)
			System.out.println("(manuelle Trennung)");
		else
			System.out.println("(Trennung durch " + this.getClass().getSimpleName() + ")");
		super.disconnect(type);
	}
	
	public EselOpt(int maxup1){
		maxup = maxup1;
	}
	
	public EselOpt(boolean read1, boolean vis1){
		this2 = this;
		read = read1;
		vis = vis1;
	}
	
	public void run() {
		while (running){
			try {
				Thread.sleep(100);
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}
		}
		if (!connected){
			System.out.println("___keine_Verbindung___");
			return;
		}
		running = true;
		if (!read && !vis){
			setOpt();
		} else if (read) {
			readOpt();
			if (vis){
				paintMe();
				vis = false;
			}
			read = false;
		}
		running = false;
	}

	private synchronized void readOpt(){
		//Optionen auslesen
		System.out.println("..... Optionen werden gelesen .....");
		setAction("?ses=" + sesID + "&w=options");
		transAction(false, Thread.currentThread().getId());
		parseOpt();
	}
	
	private synchronized void setOpt(){
		//Optionen setzen
		System.out.println("..... Optionen werden gesetzt .....");
		setAction("?ses=" + sesID + "&w=options&saveprefs=true" + (gzip.equals("ON")?("&gzip=" + gzip):"") + "&maxcapdown=" + maxcapdown + "&maxcapup=" + maxcapup + "&maxdown=" + maxdown + "&maxup=" + maxup + "&maxsources=" + maxsources + "&maxconnections=" + maxconnections + "&maxconnectionsperfive=" + maxconnectionsperfive);
		transAction(true, Thread.currentThread().getId());
		releaseSb(Thread.currentThread().getId());
	}
	
	private synchronized void parseOpt(){
		try {
			StringBuffer tmpSb;
			tmpSb = getMySB(Thread.currentThread().getId());
			int i = EselMainVis.parseHeader(tmpSb);
			if (tmpSb.indexOf(String.valueOf(sesID))!=-1 && sesID!=0){
				System.out.println("..... parse Optionen .....");
				for (; i<tmpSb.length() && i!=-1;){
					int end = tmpSb.indexOf("\n", i+1)==-1?tmpSb.length():tmpSb.indexOf("\n", i+1);
					String tmpStr = tmpSb.substring(i, end);
					if (tmpStr.contains("Gzip Komprimierung"))
						gzip = tmpStr.contains("checked")?"ON":"OFF";
					if (tmpStr.contains("maxcapdown"))
						maxcapdown = Integer.parseInt(tmpStr.substring(tmpStr.indexOf("value")+7, tmpStr.indexOf("\"> KB/s:")));
					if (tmpStr.contains("maxcapup"))
						maxcapup = Integer.parseInt(tmpStr.substring(tmpStr.indexOf("value")+7, tmpStr.indexOf("\"> KB/s:")));
					if (tmpStr.contains("maxdown"))
						maxdown = Integer.parseInt(tmpStr.substring(tmpStr.indexOf("value")+7, tmpStr.indexOf("\"> KB/s:")));
					if (tmpStr.contains("maxup"))
						maxup = Integer.parseInt(tmpStr.substring(tmpStr.indexOf("value")+7, tmpStr.indexOf("\"> KB/s:")));
					if (tmpStr.contains("maxsources"))
						maxsources = Integer.parseInt(tmpStr.substring(tmpStr.indexOf("value")+7, tmpStr.indexOf("\"></td>")));
					if (tmpStr.contains("maxconnections size"))
						maxconnections = Integer.parseInt(tmpStr.substring(tmpStr.indexOf("value")+7, tmpStr.indexOf("\"></td>")));
					if (tmpStr.contains("maxconnectionsperfive"))
						maxconnectionsperfive = Integer.parseInt(tmpStr.substring(tmpStr.indexOf("value")+7, tmpStr.indexOf("\"></td>")));
					i = end;
				}
			} else {
				disconnectModule(1);
				releaseSb(Thread.currentThread().getId());
				return;
			}
			releaseSb(Thread.currentThread().getId());
		} catch (StringBufferNotFoundExeption e) {
			e.printStackTrace();
		}
	}
	
	private synchronized void fillForm() {
		gzipCheck.setSelected(gzip.equals("ON")?true:false);
		dlBWText.setText(new Integer(maxcapdown).toString());
		ulBWText.setText(new Integer(maxcapup).toString());
		dlLimText.setText(new Integer(maxdown).toString());
		ulLimText.setText(new Integer(maxup).toString());
		maxSrcText.setText(new Integer(maxsources).toString());
		maxConnText.setText(new Integer(maxconnections).toString());
		maxConnPer5Text.setText(new Integer(maxconnectionsperfive).toString());
	}
	
	public void paintMe(){
		new JDialog(){
			private static final long serialVersionUID = 1L;
			{
				setTitle("eMule-Optionen");
				setModal(true);
				setAlwaysOnTop(true);
				setSize(420, 370);
				setResizable(false);
				Point center = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint();
				setLocation(new Double(center.getX()).intValue()-210, new Double(center.getY()).intValue()-185);
				setLayout(new BorderLayout());
				
				JPanel webServer = new JPanel();
				webServer.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(new Color(150, 150, 150)), "Webserver"));
				webServer.setPreferredSize(new Dimension(416, 70));
				webServer.setLayout(new BorderLayout());
				add(webServer, BorderLayout.NORTH);
				JLabel gzipLab = new JLabel("Spart Bandbreite bei der Datenbertragung");
				webServer.add(gzipCheck, BorderLayout.NORTH);
				webServer.add(gzipLab, BorderLayout.WEST);
				JPanel eselOpt = new JPanel();
				eselOpt.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(new Color(150, 150, 150)), "eMule-Optionen"));
				eselOpt.setPreferredSize(new Dimension(416, 240));
				eselOpt.setLayout(new FlowLayout(0));
				add(eselOpt, BorderLayout.CENTER);
				JPanel optBW = new JPanel();
				optBW.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(new Color(150, 150, 150)), "Bandbreiten"));
				optBW.setPreferredSize(new Dimension(400, 55));
				FlowLayout fl = new FlowLayout(1);
				fl.setAlignment(FlowLayout.LEFT);
				optBW.setLayout(fl);
				eselOpt.add(optBW);
				JLabel dlBWLab1 = new JLabel("Download:");
				JLabel dlBWLab2 = new JLabel("kB/s");
				dlBWText = new JTextField();
				dlBWText.setPreferredSize(new Dimension(35, 20));
				JLabel sep1 = new JLabel("   ");
				JLabel ulBWLab1 = new JLabel("Upload:");
				JLabel ulBWLab2 = new JLabel("kB/s");
				ulBWText = new JTextField();
				ulBWText.setPreferredSize(new Dimension(35, 20));
				optBW.add(dlBWLab1);
				optBW.add(dlBWText);
				optBW.add(dlBWLab2);
				optBW.add(sep1);
				optBW.add(ulBWLab1);
				optBW.add(ulBWText);
				optBW.add(ulBWLab2);
				JPanel optLim = new JPanel();
				optLim.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(new Color(150, 150, 150)), "Limits"));
				optLim.setPreferredSize(new Dimension(400, 55));
				optLim.setLayout(fl);
				eselOpt.add(optLim);
				JLabel dlLimLab1 = new JLabel("Download:");
				JLabel dlLimLab2 = new JLabel("kB/s");
				dlLimText = new JTextField();
				dlLimText.setPreferredSize(new Dimension(35, 20));
				JLabel sep2 = new JLabel("   ");
				JLabel ulLimLab1 = new JLabel("Upload:");
				JLabel ulLimLab2 = new JLabel("kB/s");
				ulLimText = new JTextField();
				ulLimText.setPreferredSize(new Dimension(35, 20));
				optLim.add(dlLimLab1);
				optLim.add(dlLimText);
				optLim.add(dlLimLab2);
				optLim.add(sep2);
				optLim.add(ulLimLab1);
				optLim.add(ulLimText);
				optLim.add(ulLimLab2);
				JPanel optConn = new JPanel();
				optConn.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(new Color(150, 150, 150)), "Verbindungs-Limits"));
				optConn.setPreferredSize(new Dimension(400, 90));
				optConn.setLayout(new GridLayout(3, 2));
				eselOpt.add(optConn);
				JLabel maxSrcLab = new JLabel("Max. Quellen je Datei:");
				JLabel maxConnLab = new JLabel("Max. Verbindungen:");
				JLabel maxConnPer5Lab = new JLabel("Max. neue Verbindungen pro 5s:");
				maxSrcText = new JTextField();
				maxSrcText.setPreferredSize(new Dimension(35, 20));
				maxConnText = new JTextField();
				maxConnText.setPreferredSize(new Dimension(35, 20));
				maxConnPer5Text = new JTextField();
				maxConnPer5Text.setPreferredSize(new Dimension(35, 20));
				optConn.add(maxSrcLab);
				optConn.add(maxSrcText);
				optConn.add(maxConnLab);
				optConn.add(maxConnText);
				optConn.add(maxConnPer5Lab);
				optConn.add(maxConnPer5Text);
				JPanel btnPanel = new JPanel();
				btnPanel.setLayout(new BorderLayout());
				JButton btJa = new JButton("OK");
				btJa.setPreferredSize(new Dimension(207, 25));
				btJa.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						try{
							gzip = gzipCheck.isSelected()?"ON":"OFF";
							maxcapdown = Integer.parseInt(dlBWText.getText());
							maxcapup = Integer.parseInt(ulBWText.getText());
							maxdown = Integer.parseInt(dlLimText.getText());
							maxup = Integer.parseInt(ulLimText.getText());
							maxsources = Integer.parseInt(maxSrcText.getText());
							maxconnections = Integer.parseInt(maxConnText.getText());
							maxconnectionsperfive = Integer.parseInt(maxConnPer5Text.getText());
							if (maxcapdown<0 || maxcapup<0 || maxdown<0 || maxup<0 || maxsources<0 || maxconnections<0 || maxconnectionsperfive<0){
								wrongInputDiolog();
							} else {
								setVisible(false);
								read = false;
								vis = false;
								Thread t = new Thread(this2);
								t.setPriority(Thread.MIN_PRIORITY);
								t.start();
							}
						} catch(NumberFormatException nfe){
							wrongInputDiolog();
						}
					}});
				JButton btNein = new JButton("Abbrechen");
				btNein.setPreferredSize(new Dimension(207, 25));
				btNein.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						setVisible(false);
					}});
				btnPanel.add(btJa, BorderLayout.WEST);
				btnPanel.add(btNein, BorderLayout.EAST);
				add(btnPanel, BorderLayout.SOUTH);
				fillForm();
				setVisible(true);
			}
		};
	}
	
	public void wrongInputDiolog(){
		new JDialog(){
			private static final long serialVersionUID = 1L;
			{
				setModal(true);
				setAlwaysOnTop(true);
				setSize(270, 140);
				setResizable(false);
				Point center = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint();
				setLocation(new Double(center.getX()).intValue()-135, new Double(center.getY()).intValue()-70);
				setTitle("Falsche Eingabe");
				setLayout(new BorderLayout());
				JLabel msg = new JLabel("<html><div align=\"center\">Alle eingegebenen Zahlen<br>mssen positive ganze Zahlen (Integer) sein!</div></html>");
				msg.setHorizontalAlignment(JLabel.CENTER);
				add(msg, BorderLayout.CENTER);
				JButton btOK = new JButton("OK");
				btOK.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						setVisible(false);
					}});
				add(btOK, BorderLayout.SOUTH);
				setVisible(true);
			}
		};
	}
	
	public static int getMaxcapup() {
		return maxcapup;
	}

	public static int getMaxup() {
		return maxup;
	}

	public static int getMaxdown() {
		return maxdown;
	}

	protected void reset() {
	}
	
}
