package remoteSystem;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.awt.font.TextLayout;

public class Graphs extends EselNet{

	private static final long serialVersionUID = 1L;

	private static int[] dlValues = new int[500];
	private static int[] ulValues = new int[500];
	private static int[] connValues = new int[500];
	private int graphLength, graphWidth, baselineX, randO, randU, randR, randGU;
	private double baselineY;
	private double faktorX, faktorY, graphHeight, maxY;
	private boolean small;
	
	public Graphs(boolean small1){
		small = small1;
		setBackground(new Color(50, 50, 80));
		if (!small)
			addMouseMotionListener(new MouseMotionListener(){
				public void mouseDragged(MouseEvent me) {
				}
				public void mouseMoved(MouseEvent me) {
					int argX = me.getX();
					int agrY = me.getY();
					int graph = inGraph(argX, agrY);
					if (graph==1)
						setTTT(new Double(dlValues[backTranslateX(argX)]).doubleValue()/1000 + " MB/s");
					else if (graph==2)
						setTTT(new Double(ulValues[backTranslateX(argX)]).doubleValue()/1000 + " MB/s");
					else if (graph==3)
						setTTT(connValues[backTranslateX(argX)] + "");
					else
						setTTT(null);
				}});
	}
	
	public void setTTT(String s){
		this.setToolTipText(s);
	}
	
	protected synchronized void disconnectModule(int type){
		if (type==0)
			System.out.println("(manuelle Trennung)");
		else
			System.out.println("(Trennung durch " + this.getClass().getSimpleName() + ")");
		super.disconnect(type);
	}

	public synchronized void reset(){
		dlValues = new int[500];
		ulValues = new int[500];
		connValues = new int[500];
		graphLength = 0;
		repaint();
	}
	
	public void run() {
		while (running){
			try {
				Thread.sleep(100);
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}
		}
		if (!connected){
			System.out.println("___keine_Verbindung___");
			reset();
			return;
		}
		running = true;
		setAction("?ses=" + sesID + "&w=graphs");
		transAction(false, Thread.currentThread().getId());
		parseGraphs();
		running = false;
	}

	private synchronized void parseGraphs() {
		try {
			StringBuffer tmpSb;
			tmpSb = getMySB(Thread.currentThread().getId());
			int i = EselMainVis.parseHeader(tmpSb);
			if (tmpSb.indexOf(String.valueOf(sesID))!=-1 && sesID!=0){
				System.out.println("..... parse Graphen .....");
				int k = 1;
				for (; i<tmpSb.length() && i!=-1;){
					int end = tmpSb.indexOf("\n", i+1)==-1?tmpSb.length():tmpSb.indexOf("\n", i+1);
					String tmpStr = tmpSb.substring(i, end);
					if (tmpStr.contains("var dlstring")){
						int j = tmpStr.indexOf("\"");
						int n = 0;
						while (j!=-1){
							i=j+1; j=tmpStr.indexOf(",", i);
							if (j==-1)
								j=tmpStr.indexOf("\"", i);
							if (j==-1)
								break;
							dlValues[n++] = Integer.parseInt(tmpStr.substring(i, j));
						}
						graphLength = n;
					}
					if (tmpStr.contains("var ulstring") && k==1){
						int j = tmpStr.indexOf("\"");
						int n = 0;
						while (j!=-1){
							i=j+1; j=tmpStr.indexOf(",", i);
							if (j==-1)
								j=tmpStr.indexOf("\"", i);
							if (j==-1)
								break;
							ulValues[n++] = Integer.parseInt(tmpStr.substring(i, j));
						}
						k = 2;
					}
					if (tmpStr.contains("var ulstring") && k==2){
						int j = tmpStr.indexOf("\"");
						int n = 0;
						while (j!=-1){
							i=j+1; j=tmpStr.indexOf(",", i);
							if (j==-1)
								j=tmpStr.indexOf("\"", i);
							if (j==-1)
								break;
							connValues[n++] = Integer.parseInt(tmpStr.substring(i, j));
						}
					}
					i = end;
				}
			} else {
				disconnectModule(1);
				releaseSb(Thread.currentThread().getId());
				return;
			}
			releaseSb(Thread.currentThread().getId());
			repaint();
		} catch (StringBufferNotFoundExeption e) {
			reset();
			e.printStackTrace();
		}
	}
	
	public synchronized void paint(Graphics g){
		super.paint(g);
		int width = this.getWidth();
		int height = this.getHeight();
		Graphics2D g2 = (Graphics2D) g;
	    g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
	    		RenderingHints.VALUE_ANTIALIAS_ON);
	    
	    //Rand
	    int borderWidth = 4;
	    for (int i=0; i<borderWidth; i++){
		    g2.setColor(new Color(50+((borderWidth-i)*30), 50+((borderWidth-i)*26), 80+((borderWidth-i)*22)));
		    g2.drawRect(i, i, width-(i*2)-1, height-(i*2)-1);
	    }
	    
	    //Zeichenrnder
	    baselineX = 28;
	    randO = 20;
	    randU = 20;
	    randGU = 0;
	    randR = 28;
	    if (small){
	    	baselineX = 5;
	 	    randO = 15;
	 	    randU = 5;
	 	    randGU = 0;
	 	    randR = 5;
	    }
	    Font font = new Font("Verdana", Font.PLAIN, 8);
	    g2.setFont(font);
	    
	    //DL-Graph zeichnen
		baselineY = Double.parseDouble((height-randGU)+"")/3-randU;
		graphWidth = width-baselineX-randR;
		int maxX = dlValues.length;
		faktorX = Double.parseDouble(graphWidth+"")/maxX;
		graphHeight = baselineY-randO;
	    maxY = getMax(dlValues)/1000;
		faktorY = Double.parseDouble(graphHeight+"")/maxY;
		if (!small){
			drawGridLines(g2);
			drawNumbers(g2, true);
		}
	    drawAxes(g2);
	    g2.setColor(new Color(255, 255, 255));
	    String drawString = "";
	    if (!small){
	    	font = new Font("Verdana", Font.PLAIN, 10);
		    g2.setFont(font);
	    	drawString = "Downloads: Max " + maxY + " kB/s";
	    } else {
	    	font = new Font("Verdana", Font.PLAIN, 8);
		    g2.setFont(font);
	    	drawString = "Max: " + maxY + " kB/s";
	    }
	    double textWidth = new TextLayout(drawString, font, g2.getFontRenderContext()).getBounds().getWidth();
	    g2.drawString(drawString, (int)((width-randR+baselineX-textWidth)/2), (int)(baselineY-graphHeight-5));
		g2.setColor(new Color(0, 255, 0));
	    for (int i=0; i<dlValues.length-1 && i<graphLength-1; i++)
	    	g2.drawLine(translateX(i+(500-graphLength)), translateLoadY(dlValues[i]), translateX(i+1+(500-graphLength)), translateLoadY(dlValues[i+1]));
	    
	    //UL-Graph zeichnen
		baselineY = (Double.parseDouble((height-randGU)+"")/3)*2-randU;
		maxY = getMax(ulValues)/1000;
		faktorY = Double.parseDouble(graphHeight+"")/maxY;
		font = new Font("Verdana", Font.PLAIN, 8);
		g2.setFont(font);
		if (!small){
			drawGridLines(g2);
			drawNumbers(g2, true);
		}
	    drawAxes(g2);
	    g2.setColor(new Color(255, 255, 255));
	    if (!small){
	    	font = new Font("Verdana", Font.PLAIN, 10);
		    g2.setFont(font);
	    	drawString = "Uploads: Max " + maxY + " kB/s";
	    } else {
	    	font = new Font("Verdana", Font.PLAIN, 8);
		    g2.setFont(font);
	    	drawString = "Max: " + maxY + " kB/s";
	    }
	    textWidth = new TextLayout(drawString, font, g2.getFontRenderContext()).getBounds().getWidth();
	    g2.drawString(drawString, (int)((width-randR+baselineX-textWidth)/2), (int)(baselineY-graphHeight-5));
	    g2.setColor(new Color(255, 0, 0));
	    for (int i=0; i<ulValues.length-1 && i<graphLength-1; i++)
	    	g2.drawLine(translateX(i+(500-graphLength)), translateLoadY(ulValues[i]), translateX(i+1+(500-graphLength)), translateLoadY(ulValues[i+1]));
	    
	    //Connection-Graph zeichnen
		baselineY = height-randGU-randU;
		maxY = getMax(connValues);
		faktorY = Double.parseDouble(graphHeight+"")/maxY;
		font = new Font("Verdana", Font.PLAIN, 8);
		g2.setFont(font);
		if (!small){
			drawGridLines(g2);
			drawNumbers(g2, false);
		}
		drawAxes(g2);
		g2.setColor(new Color(255, 255, 255));
		if (!small){
		    font = new Font("Verdana", Font.PLAIN, 10);
			g2.setFont(font);
			drawString = "Aktive Verbindungen: Max " + (int)maxY;
		} else {
			font = new Font("Verdana", Font.PLAIN, 8);
		    g2.setFont(font);
			drawString = "Max: " + (int)maxY;
		}
	    textWidth = new TextLayout(drawString, font, g2.getFontRenderContext()).getBounds().getWidth();
	    g2.drawString(drawString, (int)((width-randR+baselineX-textWidth)/2), (int)(baselineY-graphHeight-5));
	    g2.setColor(new Color(150, 180, 255));
	    for (int i=0; i<connValues.length-1 && i<graphLength-1; i++)
	    	g2.drawLine(translateX(i+(500-graphLength)), translateY(connValues[i]), translateX(i+1+(500-graphLength)), translateY(connValues[i+1]));
	}

	private void drawGridLines(Graphics2D g){
		g.setColor(new Color(100, 100, 100));
	    int step = (((int)maxY-((int)maxY%5))/5);
	    for (int i=step; i<=maxY && step>0; i+=step)
	    	g.drawLine(baselineX-2, translateY(i), this.getWidth()-randR, translateY(i));
	    for (int i=5; i<26; i+=5)
	    	g.drawLine(translateX(i*20), (int)baselineY+2, translateX(i*20), (int)(baselineY-graphHeight));
	}
	
	public void drawAxes(Graphics2D g){
		g.setColor(new Color(200, 200, 200));
	    g.drawLine(baselineX, (int)(baselineY-graphHeight), baselineX, (int)baselineY);
	    g.drawLine(baselineX, (int)baselineY, baselineX+graphWidth, (int)baselineY);
	}
	
	public void drawNumbers(Graphics2D g, boolean kB){
		g.setColor(new Color(255, 255, 255));
		String drawString;
		double textWidth;
		int step = (((int)maxY-((int)maxY%5))/5);
		for (int i=0; i<=maxY && step>0; i+=step){
	    	drawString = i + "";
	    	textWidth = new TextLayout(drawString, g.getFont(), g.getFontRenderContext()).getBounds().getWidth();
		    g.drawString(drawString, (int)((baselineX-textWidth)/2), translateY(i)+3);
	    }	 
	    for (int i=0; i<26; i+=5){
	    	drawString = i + "";
	    	textWidth = new TextLayout(drawString, g.getFont(), g.getFontRenderContext()).getBounds().getWidth();
		    g.drawString(drawString, (int)(translateX((25-i)*20)-(textWidth/2)), (int)baselineY+12);
	    }
	    drawString = "min";
    	textWidth = new TextLayout(drawString, g.getFont(), g.getFontRenderContext()).getBounds().getWidth();
	    g.drawString(drawString, (int)(this.getWidth()-((randR+textWidth)/2)), (int)baselineY+12);
	    if (kB){
		    drawString = "kB/s";
		    textWidth = new TextLayout(drawString, g.getFont(), g.getFontRenderContext()).getBounds().getWidth();
		    g.drawString(drawString, (int)((baselineX-textWidth)/2), (int)(baselineY-graphHeight-5));
	    }
	}
	
	private int translateX(int value){
		int retVal = baselineX + (int)(Double.parseDouble(value+"")*faktorX);
		return retVal;
	}
	private int backTranslateX(int value){
		int retVal = (int)(new Double(value-baselineX).doubleValue()/faktorX)-(500-graphLength);
		if (retVal>=graphLength)
			retVal = graphLength-1;
		if (retVal<0)
			retVal = 0;
		return retVal;
	}
	
	private int translateLoadY(int value){
		int retVal = (int)(baselineY - ((Double.parseDouble(value+"")/1000)*faktorY));
		if (maxY == 0)
			retVal = (int)baselineY;
		return retVal;
	}
	
	private int translateY(int value){
		int retVal = (int)(baselineY - (Double.parseDouble(value+"")*faktorY));
		if (maxY == 0)
			retVal = (int)baselineY;
		return retVal;
	}

	private synchronized double getMax(int[] array){
		double max = 0;
		for (int i=0; i<array.length; i++)
			max=array[i]>max?array[i]:max;
		return max;
	}
	
	private synchronized int inGraph(int x, int y){
		int height = this.getHeight();
		if (x<baselineX || x>baselineX+graphWidth || x<translateX(500-graphLength))
			return 0;
		baselineY = Double.parseDouble((height-randGU)+"")/3-randU;
		if (y<baselineY && y>baselineY-graphHeight)
			return 1;
		baselineY = (Double.parseDouble((height-randGU)+"")/3)*2-randU;
		if (y<baselineY && y>baselineY-graphHeight)
			return 2;
		baselineY = height-randGU-randU;
		if (y<baselineY && y>baselineY-graphHeight)
			return 3;
		return 0;
	}
	
}
