package remoteSystem;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GraphicsEnvironment;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowStateListener;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.prefs.Preferences;
import java.lang.ProcessBuilder;
import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.jdesktop.jdic.tray.SystemTray;
import org.jdesktop.jdic.tray.TrayIcon;

public class Gui extends JFrame{

	private static final long serialVersionUID = 1L;

	private static EselNet eselModules[] = new EselNet[2];
	private static JTabbedPane tabs = new JTabbedPane();
	private static EselMainVis emv;
	private static Ed2k ed2k;
	private static final Gui singleton = new Gui();
	private Container cp;
	private static Timer timer;
	private static int lastState = 6;
	private static TrayIcon ti;
	private static ImageIcon ia_grey;
	private static ImageIcon ia_colored;
	private static SystemTray st;
	private static JCheckBoxMenuItem tray_on;
	private static JCheckBoxMenuItem tray_off;
	private static JCheckBoxMenuItem tray_whenmin;
	private static JCheckBoxMenuItem tray_disposewit;
	private static JCheckBoxMenuItem opt_Sound;
	private static JCheckBoxMenuItem opt_AutoConn;
	private static JCheckBoxMenuItem opt_UpdateOnStart;
	private static JCheckBoxMenuItem opt_miniGraphs;
	private static JMenuItem help_Update;
	private static JMenuItem stUpload;
	private static JMenu opt_Admin;
	private static JCheckBoxMenuItem stMiniGraphs;
	private static JMenuItem opt_Opt;
	
	private static MiniGraphs miniGraphs = new MiniGraphs();
	
	private Gui(){
		//Allgemeine Einstellungen des Frames
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setLocation(0,0);
		Rectangle screenSize = GraphicsEnvironment.getLocalGraphicsEnvironment().getMaximumWindowBounds();
		this.setSize(screenSize.width, screenSize.height);
		this.setTitle("EselRemote " + Update.getVersion());
		this.setIconImage(new ImageIcon(getClass().getResource("h_server.gif")).getImage());
		//Merken des letzten WindowState & TrayIcon anzeigen
		this.addWindowStateListener(new WindowStateListener(){
			public void windowStateChanged(WindowEvent arg0) {
				int tmpState = getExtendedState();
				if (ti!=null){
					if (tmpState!=7 && tmpState!=1){
						if (tray_whenmin.getState() && !(lastState==0 && tmpState==6) && !(lastState==6 && tmpState==0))
							st.removeTrayIcon(ti);
						lastState = tmpState;
					} else {
						if (tray_whenmin.getState()){
							st.addTrayIcon(ti);
							if (tray_disposewit.getState())
								setVisible(false);
						} else if (tray_on.getState() && tray_disposewit.getState()){
							setVisible(false);
						}
					}
				}
				//TODO Mindest-Fenstergre
			}});
		
		//Haupt-Container und Layout
		cp = this.getContentPane();
		cp.setLayout(new BorderLayout());
		tabs.setPreferredSize(new Dimension(1274, 845));
		
		//Hinzufgen der Hauptkomponenten
		this.setJMenuBar(createMenuBar());
		emv = new EselMainVis();
		cp.add(emv, BorderLayout.NORTH);
		cp.add(tabs, BorderLayout.CENTER);
		
		//Esel-Module werden erstellt und auf die Tabs gelegt
		eselModules[0] = new Transfer();
		tabs.addTab("Transfer", new ImageIcon(getClass().getResource("h_transfer.gif")), eselModules[0]);
		eselModules[1] = new Graphs(false);
		tabs.addTab("Graphen", new ImageIcon(getClass().getResource("h_graph.gif")), eselModules[1]);
		
		//ChangeListener um bei Wechsel auf einen Tab die Daten zu aktualisieren
		tabs.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent arg0) {
				Thread t = new Thread(eselModules[tabs.getSelectedIndex()]);
				t.setPriority(Thread.MIN_PRIORITY);
				t.start();
			}});
		
		//TrayIcon!!! :-)
		st = SystemTray.getDefaultSystemTray();
		ia_grey = new ImageIcon(getClass().getResource("h_server_grey.gif"));
		ia_colored = new ImageIcon(getClass().getResource("h_server.gif"));
		ti = new TrayIcon(ia_grey, this.getTitle());
		JPopupMenu sysMenu = new JPopupMenu();
		JMenuItem stRe = new JMenuItem("Wiederherstellen");
		stRe.setIcon(new ImageIcon(getClass().getResource("h_server.gif")));
		stRe.setFont(new Font("Verdana", Font.BOLD, 10));
		stRe.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				setVisible(true);
				setExtendedState(lastState);
			}});
		sysMenu.add(stRe);
		stUpload = new JMenuItem("Upload-Limit");
		stUpload.setEnabled(false);
		stUpload.setIcon(new ImageIcon(getClass().getResource("arrow_up.gif")));
		stUpload.setFont(new Font("Verdana", Font.PLAIN, 10));
		stUpload.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				new TrayUploadThrottle();
			}});
		sysMenu.add(stUpload);
		stMiniGraphs = new JCheckBoxMenuItem("Mini-Graphen");
		stMiniGraphs.setIcon(new ImageIcon(getClass().getResource("h_graph.gif")));
		stMiniGraphs.setFont(new Font("Verdana", Font.PLAIN, 10));
		stMiniGraphs.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				miniGraphs.setVisible(stMiniGraphs.isSelected());
			}});
		sysMenu.add(stMiniGraphs);
		JMenuItem stClose = new JMenuItem("Beenden");
		stClose.setIcon(new ImageIcon(getClass().getResource("l_close.gif")));
		stClose.setFont(new Font("Verdana", Font.PLAIN, 10));
		stClose.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				System.exit(0);
			}});
		sysMenu.add(stClose);
		ti.setPopupMenu(sysMenu);
		ti.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae) {
				if (ae.getActionCommand().equals("PressAction")){
					setVisible(true);
					setExtendedState(lastState);
					toFront();
				}
			}});
		if (tray_on.getState())
			st.addTrayIcon(ti);
		
		//Anzeige
		this.pack();
		this.setExtendedState(6);
		this.setVisible(true);
		
		//Connect und starten des ersten Moduls
		ed2k = new Ed2k();
		ed2k.getSize();
		Optionen.initMule();
		if (opt_AutoConn.getState()){
			Thread t1 = new Thread(new Connect(true));
			t1.setPriority(Thread.MIN_PRIORITY);
			t1.start();
		}
		if (opt_UpdateOnStart.getState()){
			Update.setAuto(true);
			new Thread(new Update()).start();
		}
		
		//Bldes anpassen der Tab-Hhe - vllig sinnlos - aber es geht nicht von alleine!!!
		cp.addComponentListener(new ComponentListener(){
			public void componentResized(ComponentEvent arg0) {
				int w = cp.getWidth();
				int h = cp.getHeight()-70;
				tabs.setPreferredSize(new Dimension(w, h));
				tabs.setLocation(0, 70);
				tabs.setSize(w, h);
			}
			public void componentMoved(ComponentEvent arg0) {
			}
			public void componentShown(ComponentEvent arg0) {
			}
			public void componentHidden(ComponentEvent arg0) {
			}});
	}
	
	public static synchronized TrayIcon getTrayIcon(){
		return ti;
	}
	
	public static synchronized Gui getGui(){
		return singleton;
	}
	
	//Manuelle Verbindung
	public static synchronized void manConnect(boolean auto1){
		Thread t1 = new Thread(new Connect(auto1));
		t1.setPriority(Thread.MIN_PRIORITY);
		t1.start();
	}
	
	public static synchronized void globalConnect(){
		if (Optionen.getAkt()!=0){
			timer = new Timer(Optionen.getAkt()*1000, new ActionListener(){
				public void actionPerformed(ActionEvent arg0) {
					Thread t = new Thread(eselModules[tabs.getSelectedIndex()]);
					t.setPriority(Thread.MIN_PRIORITY);
					t.start();
					if (miniGraphs.isVisible())
						MiniGraphs.aktualize();
				}});
			timer.start();
			System.out.println("Starte Timer mit Intervall: " + timer.getDelay()/1000 + "s");
		}
		ti.setIcon(ia_colored);
		stUpload.setEnabled(true);
		opt_Opt.setEnabled(true);
		Thread t2 = new Thread(eselModules[tabs.getSelectedIndex()]);
		t2.setPriority(Thread.MIN_PRIORITY);
		t2.start();
		if (miniGraphs.isVisible())
			MiniGraphs.aktualize();
		singleton.setTitle("EselRemote " + Update.getVersion() + " @ " + EselNet.getHost());
		ti.setCaption(singleton.getTitle());
		Thread t = new Thread(new EselOpt(true, false));
		t.setPriority(Thread.MIN_PRIORITY);
		t.start();
	}
	
	public static synchronized void globalDisconnect(){
		if (timer!=null)
			timer.stop();
		ti.setIcon(ia_grey);
		stUpload.setEnabled(false);
		opt_Opt.setEnabled(false);
		opt_Admin.setEnabled(false);
		singleton.setTitle("EselRemote " + Update.getVersion());
		ti.setCaption(singleton.getTitle());
		//Reset aller eselModules
		for (int i=0; i<eselModules.length; i++){
			System.out.println("   Setze " + eselModules[i].getClass().getSimpleName() + " zurck");
			eselModules[i].reset();
		}
		System.out.println("   Setze " + miniGraphs.getClass().getSimpleName() + " zurck");
		miniGraphs.reset();
	}
	
	//Manueller Verbindungsabbruch
	public static synchronized void manDisconnect(){
		eselModules[tabs.getSelectedIndex()].disconnectModule(0);
	}
	
	public static synchronized void runCurrentModule(){
		Thread t = new Thread(eselModules[tabs.getSelectedIndex()]);
		t.setPriority(Thread.MIN_PRIORITY);
		t.start();
	}
	
	//temprre Funktion um Gre der transferTabelle anzupassen - sollte vielleicht noch gendert werden
	//Wichtig: hierbei findet keine Kommunikation mit dem WebServer statt
	public static synchronized void updateModules(){
		((Transfer) eselModules[0]).getDlTM().fireTableDataChanged();
		((Transfer) eselModules[0]).setTPSize();
	}
	
	public static synchronized boolean isSoundOn(){
		return opt_Sound.getState();
	}
	
	public static synchronized boolean isAutoConnOn(){
		return opt_AutoConn.getState();
	}
	
	public static synchronized EselNet getSelectedModule(){
		return eselModules[tabs.getSelectedIndex()];
	}
	
	public static synchronized void setMGChekBoxes(boolean vis){
		stMiniGraphs.setSelected(vis);
		opt_miniGraphs.setSelected(vis);
	}
	
	public static synchronized void setAdmin(boolean state){
		opt_Admin.setEnabled(state);
	}
	
	//Die Menleiste
	private JMenuBar createMenuBar(){
		
		final Preferences prefs = Preferences.userRoot().node("/EselRemote/Options");
		JMenu datei = new JMenu("Datei");
		JMenuItem datei_Exit = new JMenuItem("Beenden", new ImageIcon(getClass().getResource("l_close.gif")));
		datei_Exit.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				System.exit(0);
			}});
		datei.add(datei_Exit);
		
		JMenu opt = new JMenu("Optionen");
		JMenu opt_Tray = new JMenu("TrayIcon");
		tray_on = new JCheckBoxMenuItem("An");
		tray_off = new JCheckBoxMenuItem("Aus");
		tray_whenmin = new JCheckBoxMenuItem("... wenn minimiert");
		tray_disposewit = new JCheckBoxMenuItem("Ausblenden, wenn in Tray minimiert");
		opt_Sound = new JCheckBoxMenuItem("Sound");
		opt_AutoConn = new JCheckBoxMenuItem("beim Start automatisch Verbinden");
		opt_UpdateOnStart = new JCheckBoxMenuItem("beim Start nach Update suchen");
		
		//Einstellungen aus Registry lesen
		String trayKey = prefs.get("tray", "whenmin");
		if (trayKey.equals("on"))
			tray_on.setSelected(true);
		else if (trayKey.equals("off"))
			tray_off.setSelected(true);
		else if (trayKey.equals("whenmin"))
			tray_whenmin.setSelected(true);
		tray_disposewit.setSelected(prefs.getBoolean("disposewit", true));
		opt_Sound.setSelected(prefs.getBoolean("sound", true));
		opt_AutoConn.setSelected(prefs.getBoolean("autoconn", true));
		opt_UpdateOnStart.setSelected(prefs.getBoolean("updateonstart", true));

		JMenuItem opt_Conn = new JMenuItem("Verbindungs-Einstellungen...", new ImageIcon(getClass().getResource("l_con.gif")));
		opt_Conn.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				Optionen.getOpt();
			}});
		opt_Opt = new JMenuItem("eMule-Optionen...", new ImageIcon(getClass().getResource("h_preferences.gif")));
		opt_Opt.setEnabled(false);
		opt_Opt.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				Thread t = new Thread(new EselOpt(true, true));
				t.setPriority(Thread.MIN_PRIORITY);
				t.start();
			}});
		opt_Admin = new JMenu("Admin");
		opt_Admin.setIcon(new ImageIcon(getClass().getResource("l_options.gif")));
		opt_Admin.setEnabled(false);
		JMenuItem admin_close = new JMenuItem("eMule beenden", new ImageIcon(getClass().getResource("l_close.gif")));
		admin_close.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				askAdmin("close");
			}});
		JMenuItem admin_restart = new JMenuItem("Server neustarten", new ImageIcon(getClass().getResource("l_reboot.gif")));
		admin_restart.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				askAdmin("reboot");
			}});
		JMenuItem admin_shutdown = new JMenuItem("Server herunterfahren", new ImageIcon(getClass().getResource("l_shutdown.gif")));
		admin_shutdown.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				askAdmin("shutdown");
			}});
		opt_Admin.add(admin_close);
		opt_Admin.add(admin_restart);
		opt_Admin.add(admin_shutdown);
		tray_on.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				tray_off.setSelected(false);
				tray_whenmin.setSelected(false);
				st.addTrayIcon(ti);
				tray_on.setSelected(true);
				prefs.put("tray", "on");
			}});
		tray_off.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				if (tray_on.getState())
					st.removeTrayIcon(ti);
				tray_on.setSelected(false);
				tray_whenmin.setSelected(false);
				tray_off.setSelected(true);
				prefs.put("tray", "off");
			}});
		tray_whenmin.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				if (tray_on.getState())
					st.removeTrayIcon(ti);
				tray_on.setSelected(false);
				tray_off.setSelected(false);
				tray_whenmin.setSelected(true);
				prefs.put("tray", "whenmin");
			}});
		tray_disposewit.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				prefs.putBoolean("disposewit", tray_disposewit.getState());
			}});
		opt_Tray.add(tray_on);
		opt_Tray.add(tray_off);
		opt_Tray.add(tray_whenmin);
		opt_Tray.addSeparator();
		opt_Tray.add(tray_disposewit);
		opt_Sound.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				prefs.putBoolean("sound", opt_Sound.getState());
			}});
		opt_AutoConn.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				prefs.putBoolean("autoconn", opt_AutoConn.getState());
			}});
		opt_UpdateOnStart.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				prefs.putBoolean("updateonstart", opt_UpdateOnStart.getState());
			}});
		JMenuItem opt_ed2k = new JMenuItem("ed2k-Links verknpfen...", new ImageIcon(getClass().getResource("l_ed2klink.gif")));
		opt_ed2k.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				ed2kSC();
			}});
		opt_miniGraphs = new JCheckBoxMenuItem("Mini-Graphen");
		opt_miniGraphs.setIcon(new ImageIcon(getClass().getResource("h_graph.gif")));
		opt_miniGraphs.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				miniGraphs.setVisible(opt_miniGraphs.isSelected());
			}});
		opt.add(opt_Conn);
		opt.addSeparator();
		opt.add(opt_Opt);
		opt.add(opt_Admin);
		opt.addSeparator();
		opt.add(opt_Tray);
		opt.add(opt_Sound);
		opt.add(opt_AutoConn);
		opt.add(opt_UpdateOnStart);
		opt.add(opt_miniGraphs);
		opt.addSeparator();
		opt.add(opt_ed2k);
		
		JMenu help = new JMenu("?");
		help_Update = new JMenuItem("Nach Update suchen...", new ImageIcon(getClass().getResource("l_version.gif")));
		help_Update.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				Thread t = new Thread(new Update());
				t.setPriority(Thread.MIN_PRIORITY);
				t.start();
			}});
		JMenuItem help_About = new JMenuItem("ber...", new ImageIcon(getClass().getResource("l_info.gif")));
		help_About.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				new About();
			}});
		help.add(help_Update);
		help.add(help_About);
		
		JMenuBar menuBar = new JMenuBar();
		menuBar.add(datei);
		menuBar.add(opt);
		menuBar.add(help);
		return menuBar;
	}
	
	private void ed2kSC(){
		new JDialog(){
			private static final long serialVersionUID = 1L;
			{
				setModal(true);
				setAlwaysOnTop(true);
				setSize(400, 120);
				setResizable(false);
				Point center = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint();
				setLocation(new Double(center.getX()).intValue()-200, new Double(center.getY()).intValue()-60);
				setTitle("ed2k-Links verknpfen");
				setLayout(new BorderLayout());
				JLabel msg = new JLabel("<html><div align=\"center\">Sollen ed2k-Links mit dem ed2kLinkCatcher verknpft werden?</div></html>");
				msg.setHorizontalAlignment(JLabel.CENTER);
				add(msg, BorderLayout.CENTER);
				JPanel btnPanel = new JPanel();
				btnPanel.setLayout(new BorderLayout());
				JButton btJa = new JButton("Ja");
				btJa.setPreferredSize(new Dimension(197, 25));
				btJa.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						regEd2k();
						setVisible(false);
					}});
				JButton btNein = new JButton("Nein");
				btNein.setPreferredSize(new Dimension(197, 25));
				btNein.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						setVisible(false);
					}});
				btnPanel.add(btJa, BorderLayout.WEST);
				btnPanel.add(btNein, BorderLayout.EAST);
				add(btnPanel, BorderLayout.SOUTH);
				setVisible(true);
			}
		};
	}
	
	private synchronized void regEd2k(){
		//In ed2k-Links mit ed2kLinkCatcher verknpfen(mit dem richtigen Arbeitsverzeichnis)
		try {
			System.out.println("Registriere ed2k-Links");
			File f = new File("rgtmpl.erm");
			File tmpRegFile = new File("ed2kLinkCatcher.reg");
			FileReader fr = new FileReader(f);
			FileWriter fw = new FileWriter(tmpRegFile);
			BufferedReader br = new BufferedReader(fr);
			BufferedWriter bw = new BufferedWriter(fw);
			String tmpLine = br.readLine();
			String tmpIconLoc = new File("ed2k.ico").getAbsolutePath().replace("\\", "\\\\");
			String tmpLCLoc = new File("ed2kLinkCatcher.jar").getAbsolutePath().replace("\\", "\\\\");;
			while (tmpLine!=null){
				if (tmpLine.contains("@=\"") && tmpLine.contains("ed2k.ico"))
					tmpLine = "@=\"" + tmpIconLoc + "\"";
				else if (tmpLine.contains("@=\"javaw.exe -jar") && tmpLine.contains("ed2kLinkCatcher.jar"))
					tmpLine = "@=\"javaw.exe -jar \\\"" + tmpLCLoc + "\\\" \\\"%1\\\"\"";
				bw.write(tmpLine);
				bw.newLine();
				tmpLine = br.readLine();
			}
			bw.close();
			br.close();
			synchronized (tmpRegFile) {
				System.out.println("   Schreibe Registry");
				String[] command = {"regedit", "/s", tmpRegFile.getAbsolutePath()};
				ProcessBuilder pb = new ProcessBuilder(command);
				synchronized (pb) {
					pb.start();
				}
			}
			System.out.println("   Lsche temporre Datei");
			tmpRegFile.delete();
		} catch (FileNotFoundException e) {
			regNotWritten();
		} catch (IOException e) {
			regNotWritten();
		}
	}
	
	private void regNotWritten(){
		System.out.println("In die Registry konnte nicht geschrieben werden!");
		new JDialog(){
			private static final long serialVersionUID = 1L;
			{
				setModal(true);
				setAlwaysOnTop(true);
				setSize(320, 120);
				setResizable(false);
				Point center = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint();
				setLocation(new Double(center.getX()).intValue()-160, new Double(center.getY()).intValue()-60);
				setTitle("Fehler");
				setLayout(new BorderLayout());
				JLabel msg = new JLabel("<html><div align=\"center\">In die Registry konnte nicht geschrieben werden!</div></html>");
				msg.setHorizontalAlignment(JLabel.CENTER);
				add(msg, BorderLayout.CENTER);
				JButton btOK = new JButton("OK");
				btOK.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						setVisible(false);
					}});
				add(btOK, BorderLayout.SOUTH);
				setVisible(true);
			}
		};
	}
	
	private synchronized void askAdmin(String state1){
		final String state = state1;
		new JDialog(){
			private static final long serialVersionUID = 1L;
			{
				setModal(true);
				setAlwaysOnTop(true);
				setSize(400, 120);
				setResizable(false);
				Point center = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint();
				setLocation(new Double(center.getX()).intValue()-200, new Double(center.getY()).intValue()-60);
				setLayout(new BorderLayout());
				JLabel msg = new JLabel();
				if (state.equals("close")){
					setTitle("eMule beenden");
					msg.setText("<html><div align=\"center\">Soll eMule wirklich beendet werden?</div></html>");
				} else if (state.equals("reboot")){
					setTitle("Server neustarten");
					msg.setText("<html><div align=\"center\">Soll der Server wirklich neugestartet werden?</div></html>");
				} else if (state.equals("shutdown")){
					setTitle("Server herunterfahren");
					msg.setText("<html><div align=\"center\">Soll der Server wirklich heruntergefahren werden?</div></html>");
				}
				msg.setHorizontalAlignment(JLabel.CENTER);
				add(msg, BorderLayout.CENTER);
				JPanel btnPanel = new JPanel();
				btnPanel.setLayout(new BorderLayout());
				JButton btJa = new JButton("Ja");
				btJa.setPreferredSize(new Dimension(197, 25));
				btJa.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						new Admin(state);
						setVisible(false);
					}});
				JButton btNein = new JButton("Nein");
				btNein.setPreferredSize(new Dimension(197, 25));
				btNein.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						setVisible(false);
					}});
				btnPanel.add(btJa, BorderLayout.WEST);
				btnPanel.add(btNein, BorderLayout.EAST);
				add(btnPanel, BorderLayout.SOUTH);
				setVisible(true);
			}
		};
	}
	
}
