package remoteSystem;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GraphicsEnvironment;
import java.awt.Point;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.URL;
import java.nio.ByteBuffer;
import java.nio.charset.Charset;
import java.util.zip.GZIPInputStream;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.JTableHeader;

public class Kommentare extends JFrame implements Runnable{
	
	private static final long serialVersionUID = 1L;
	private static String filehash;
	private static String fileName;
	private static StringBuffer sb;

	public Kommentare(String fn, String fh){
		fileName = fn.replace("<html>", "").replace("</html>", "");
		filehash = fh;
		Thread t = new Thread(this);
		t.setPriority(Thread.MIN_PRIORITY);
		t.start();
	}
	
	public void run(){
		try {
			System.out.println("..... hole Kommentare .....");
			boolean isgzip = true;
			InputStream gzip = null;
			BufferedReader in;
			URL commentURL = new URL("http", EselNet.host, EselNet.port, "?ses=" + EselNet.sesID + "&w=commentlist&filehash=" + filehash);
			try {
				gzip = new GZIPInputStream(commentURL.openStream());
			} catch (IOException e){
				isgzip = false;
			}
			if (isgzip){
				Reader gzipReader = new InputStreamReader(gzip);
				in = new BufferedReader(gzipReader);
			} else {
				Reader is = new InputStreamReader(commentURL.openStream());
				in = new BufferedReader(is);
			}
			sb = new StringBuffer();
			for (String s; (s=in.readLine())!=null;){
				sb.append(s + "\n");
			}
			in.close();
			paintMe();
		} catch (IOException e) {
			System.out.println("Verbindungsfehler: " + e);
		}
	}
	
	private void paintMe(){
		this.setTitle("Kommentare: " + fileName);
		JPanel tablePane = new JPanel();
		tablePane.setLayout(new BorderLayout());
		JScrollPane scrollPane = new JScrollPane(tablePane);
		scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		scrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		KommTM tm = new KommTM();
		JTable komm = new JTable(tm);
		JTableHeader th = komm.getTableHeader();
		th.getColumnModel().getColumn(0).setPreferredWidth(180);
		th.getColumnModel().getColumn(1).setPreferredWidth(320);
		th.getColumnModel().getColumn(2).setPreferredWidth(320);
		th.getColumnModel().getColumn(3).setPreferredWidth(180);
		tablePane.add(th, BorderLayout.NORTH);
		komm.setFont(new Font("Verdana", Font.PLAIN, 12));
		komm.setSelectionBackground(new Color(255, 255, 255));
		komm.setCellSelectionEnabled(false);
		komm.setRowSelectionAllowed(true);
		tablePane.add(komm, BorderLayout.CENTER);
		this.add(scrollPane);
		parseComments(tm);
		this.setSize(new Dimension(1024, (tm.getRowCount()*16)+53));
		Point center = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint();
		this.setLocation(new Double(center.getX()).intValue()-512, new Double(center.getY()).intValue()-(this.getHeight()/2));
		this.setIconImage(new ImageIcon(getClass().getResource("h_server.gif")).getImage());
		this.setVisible(true);
	}
	
	private void parseComments(KommTM tm){
		System.out.println("..... parse Kommentare .....");
		String[] tmpKomm = new String[4];
		for (int i=0; i<sb.length() && i!=-1;){
			int end = sb.indexOf("\n", i+1)==-1?sb.length():sb.indexOf("\n", i+1);
			String tmpStr = sb.substring(i, end);
			i = end;
//			System.out.println("|" + tmpStr.replace("\n",""));
			if (tmpStr.contains("<td align=\"left\"")){
				tmpKomm = new String[4];
				for (int j=0; j<4; j++){
					Charset charset = Charset.forName("UTF-8");
					ByteBuffer bb = ByteBuffer.allocate(10240);
					bb.put(tmpStr.getBytes());
					bb.position(0);
					String tmpStr2 = charset.decode(bb).subSequence(0,2000).toString();
					tmpKomm[j] = "<html>" + tmpStr2.substring(tmpStr2.indexOf(";\">")+3, tmpStr2.indexOf("</font>")) + "</html>";
					end = sb.indexOf("\n", i+1)==-1?sb.length():sb.indexOf("\n", i+1);
					tmpStr = sb.substring(i, end);
					i = end;
				}
				System.out.println(" + " + tmpKomm[0] + " | " + tmpKomm[1] + " | " + tmpKomm[2] + " | " + tmpKomm[3]);
				tm.addComment(tmpKomm);
			}
		}
	}
	
	private class KommTM extends AbstractTableModel{
		
		private static final long serialVersionUID = 1L;
		
		private String[] header = {"Benutzer","Dateiname","Kommentar","Bewertung"};
		private String[][] data = new String[0][4];
		
		public int getRowCount() {
			return data.length;
		}
		
		public int getColumnCount() {
			return header.length;
		}
		
		public String getColumnName(int col) {
			return header[col];
		}
		
		public Class getColumnClass(int col) {
			return String.class;
		}
		
		public boolean isCellEditable(int arg0, int arg1) {
			return false;
		}
		
		public Object getValueAt(int row, int col) {
			return data[row][col];
		}
		
		public void setValueAt(Object arg0, int arg1, int arg2) {
		}
		
		public void addComment(String[] comments){
			String[][] tmpData = new String[data.length+1][4];
			int i;
			for (i=0; i<data.length; i++)
				tmpData[i] = data[i];
			tmpData[data.length] = comments;
			data = tmpData;
		}
		
		public void addTableModelListener(TableModelListener arg0) {
		}
		
		public void removeTableModelListener(TableModelListener arg0) {
		}
	}
	
}
