package remoteSystem;

import java.awt.GraphicsEnvironment;
import java.awt.MouseInfo;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.prefs.Preferences;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JDialog;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class MiniGraphs extends JDialog{
	
	private static final long serialVersionUID = 1L;
	
	private int mouseX, mouseY;
	private static Graphs g = new Graphs(true);
	private static Preferences prefs = Preferences.userRoot().node("/EselRemote/Options");
	
	public MiniGraphs(){
		setTitle("Mini-Graphen");
		setUndecorated(true);
		setSize(115, 115);
		Rectangle r = GraphicsEnvironment.getLocalGraphicsEnvironment().getMaximumWindowBounds();
		setLocation(r.width-getWidth(), r.height-getHeight());
		add(g);
		g.setComponentPopupMenu(createPopupMenu());
		addMouseMotionListener(new MouseMotionListener(){
			public void mouseDragged(MouseEvent arg0) {
				Point mouseLocation = MouseInfo.getPointerInfo().getLocation();
				setLocation(mouseLocation.x-mouseX, mouseLocation.y-mouseY);
			}
			public void mouseMoved(MouseEvent arg0) {
				mouseX = arg0.getX();
				mouseY = arg0.getY();
			}});
		addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent arg0) {
				if (arg0.getClickCount()==2 && !arg0.isPopupTrigger()){
					dispose();
					setUndecorated(!isUndecorated());
					if (isUndecorated()){
						setSize(g.getSize());
						setLocation(getLocation().x+4, getLocation().y+30);
					}
					else{
						setSize(g.getSize().width+8, g.getSize().height+34);
						setLocation(getLocation().x-4, getLocation().y-30);
					}
					setVisible(true);
				}else if (arg0.getClickCount()==1 && arg0.getButton()==MouseEvent.BUTTON3){
					g.getComponentPopupMenu().show(g, arg0.getX(), arg0.getY());
				}
			}
			public void mousePressed(MouseEvent arg0) {
			}
			public void mouseReleased(MouseEvent arg0) {
			}
			public void mouseEntered(MouseEvent arg0) {
			}
			public void mouseExited(MouseEvent arg0) {
			}});
		addWindowListener(new WindowListener(){
			public void windowOpened(WindowEvent arg0) {
			}
			public void windowClosing(WindowEvent arg0) {
				Gui.setMGChekBoxes(false);
			}
			public void windowClosed(WindowEvent arg0) {
			}
			public void windowIconified(WindowEvent arg0) {
			}
			public void windowDeiconified(WindowEvent arg0) {
			}
			public void windowActivated(WindowEvent arg0) {
			}
			public void windowDeactivated(WindowEvent arg0) {
			}});
		//setVisible() aus Registry
		setVisible(prefs.getBoolean("mgVisible", false));
	}
	
	public static void aktualize(){
		Thread t = new Thread(g);
		t.setPriority(Thread.MIN_PRIORITY);
		t.start();
	}
	
	public void setVisible(boolean vis){
		super.setVisible(vis);
		if (vis)
			aktualize();
		//in Registry speichern
		prefs.putBoolean("mgVisible", vis);
		Gui.setMGChekBoxes(vis);
	}
	
	private JPopupMenu createPopupMenu(){
		//Popup-Men fr Mini-Graphen erstellen
		JPopupMenu pop = new JPopupMenu();
		final JCheckBoxMenuItem saot = new JCheckBoxMenuItem("immer im Vordergrund");
		saot.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent arg0) {
				setAlwaysOnTop(saot.isSelected());
				//in Registry speichern
				prefs.putBoolean("mgAOT", saot.isSelected());
			}});
		//setAllwaysOnTop() aus Registry
		saot.setSelected(prefs.getBoolean("mgAOT", false));
		JMenuItem close = new JMenuItem("Mini-Graphen schlieen");
		close.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				setVisible(false);
			}});
		pop.add(saot);
		pop.add(close);
		return pop;
	}
	
	public void reset(){
		g.reset();
	}
	
}
