package remoteSystem;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GraphicsEnvironment;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.prefs.Preferences;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

public class Optionen extends JDialog{
	
	private static final long serialVersionUID = 1L;
	
	private static Optionen opt;
	private static JLabel lblHost = new JLabel("eMule-WebServer:");
	private static JLabel lblPort = new JLabel("WebServer-Port:");
	private static JLabel lblPass = new JLabel("Passwort:");
	private static JLabel lblAkt = new JLabel("Aktuallisierungs-Intervall in s (0 = ohne):");
	private static JTextField txHost = new JTextField();
	private static JTextField txPort = new JTextField();
	private static JPasswordField txPass = new JPasswordField();
	private static JTextField txAkt = new JTextField();
	private static JButton ok = new JButton("OK");
	private static JButton cancel = new JButton("Abbrechen");
	private static Preferences prefs = Preferences.userRoot().node("/EselRemote/Connection");
	
	private Optionen(){
		opt = this;
		Point center = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint();
		setLocation(new Double(center.getX()).intValue()-250, new Double(center.getY()).intValue()-79);
		opt.setTitle("Verbindungs-Einstellungen");
		opt.setSize(new Dimension(500, 157));
		opt.setModal(true);
		opt.setAlwaysOnTop(true);
		opt.setResizable(false);
		
		GridLayout grid = new GridLayout(5, 2);
		opt.setLayout(grid);
		
		ok.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				//TextFeld-Validierung (Port und Aktuallisierung-Intervall mssen Int sein)
				try{
					int port = Integer.parseInt(txPort.getText());
					int aktInt = Integer.parseInt(txAkt.getText());
					if (port < 1 || aktInt==0 || (aktInt>10 && aktInt<90)){
						opt.setVisible(false);
						setKeys();
					} else
						wrongInputDiolog();
				} catch(NumberFormatException nfe){
					wrongInputDiolog();
				}
			}});
		cancel.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				opt.setVisible(false);
			}});
		
		opt.add(lblHost);
		opt.add(txHost);
		opt.add(lblPort);
		opt.add(txPort);
		opt.add(lblPass);
		opt.add(txPass);
		opt.add(lblAkt);
		opt.add(txAkt);
		opt.add(ok);
		opt.add(cancel);
		
		getKeys();
		opt.setVisible(true);
	}
	
	public void wrongInputDiolog(){
		new JDialog(){
			private static final long serialVersionUID = 1L;
			{
				setModal(true);
				setAlwaysOnTop(true);
				setSize(270, 140);
				setResizable(false);
				Point center = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint();
				setLocation(new Double(center.getX()).intValue()-135, new Double(center.getY()).intValue()-70);
				setTitle("Falsche Eingabe");
				setLayout(new BorderLayout());
				JLabel msg = new JLabel("<html><div align=\"center\">Der Port und das Aktuallisierungs-Intervall<br>mssen positive ganze Zahlen (Integer) sein!<br>(10 &lt; Aktuallisierungs-Intervall &lt; 90)</div></html>");
				msg.setHorizontalAlignment(JLabel.CENTER);
				add(msg, BorderLayout.CENTER);
				JButton btOK = new JButton("OK");
				btOK.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						setVisible(false);
					}});
				add(btOK, BorderLayout.SOUTH);
				setVisible(true);
			}
		};
	}
	
	public static synchronized Optionen getOpt(){
		if (opt==null)
			new Optionen();
		else{
			getKeys();
			opt.setVisible(true);
		}
		return opt;
	}
	
	private static synchronized void getKeys(){
		//Registry-Schlssel auslesen und in die Textfelder schreiben
		System.out.println("Auslesen der Registry-Schlssel...");
		txHost.setText(prefs.get("host", ""));
		txPort.setText(new Integer(prefs.getInt("port", 4711)).toString());
		txPass.setText(prefs.get("pass", ""));
		txAkt.setText(prefs.get("aktint", "60"));
	}
	
	private static synchronized void setKeys(){
		//Werte aus den Textfeldern in die Registry schreiben
		System.out.println("Speichern der Werte in die Registry...");
		prefs.put("host", txHost.getText());
		prefs.putInt("port", Integer.parseInt(txPort.getText()));
		prefs.put("pass", new String(txPass.getPassword()));
		prefs.putInt("aktint", Integer.parseInt(txAkt.getText()));
		initMule();
	}
	
	public static synchronized void initMule(){
		getKeys();
		boolean connected = EselNet.connected;
		if (connected)
			Gui.manDisconnect();
		EselNet.setMule(Optionen.getHost(), Optionen.getPort(), Optionen.getPass());
		if (connected)
			Gui.manConnect(true);
	}
	
	public static String getHost(){
		return txHost.getText();
	}
	
	public static int getPort(){
		return Integer.parseInt(txPort.getText());
	}
	
	public static String getPass(){
		return new String(txPass.getPassword());
	}
	
	public static int getAkt(){
		return Integer.parseInt(txAkt.getText());
	}

}
