package remoteSystem;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.nio.ByteBuffer;
import java.nio.charset.Charset;
import java.util.LinkedList;
import javax.swing.*;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableCellRenderer;

public class Transfer extends EselNet{

	private static final long serialVersionUID = 1L;

	private static LinkedList dlFile = new LinkedList();
	private static LinkedList ulFile = new LinkedList();
	private JPanel tablePane = new JPanel();
	private JScrollPane scrollPane = new JScrollPane(tablePane);
	private DlTableModel tmDl = new DlTableModel();
	private UlTableModel tmUl = new UlTableModel();
	private JTable tableDl = new JTable(tmDl);
	private JTable tableUl = new JTable(tmUl);
	private JTableHeader thDl = tableDl.getTableHeader();
	private JTableHeader thUl = tableUl.getTableHeader();
	private JLabel labDl = new JLabel("Downloads:   0", new ImageIcon(getClass().getResource("arrow_down.gif")), JLabel.LEFT);
	private JLabel labUl = new JLabel("Uploads:   0", new ImageIcon(getClass().getResource("arrow_up.gif")), JLabel.LEFT);
		
	public Transfer(){
		this.setLayout(new BorderLayout());
		
		SpringLayout tableLayout = new SpringLayout();
		tablePane.setLayout(tableLayout);
		
		tablePane.setPreferredSize(new Dimension(1266, 1));
		tableDl.setPreferredSize(new Dimension(1266, tableDl.getHeight()));
		tableUl.setPreferredSize(new Dimension(1266, tableUl.getHeight()));
		tableDl.setSelectionMode(0);
		tableUl.setSelectionMode(0);
//		tableDl.setGridColor(this.getBackground());
		
		scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
		scrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
				
		tableDl.setFont(new Font("Verdana", Font.PLAIN, 12));
		tableUl.setFont(new Font("Verdana", Font.PLAIN, 12));
		thDl.setFont(new Font("Verdana", Font.PLAIN, 12));
		thUl.setFont(new Font("Verdana", Font.PLAIN, 12));
		thDl.getColumnModel().getColumn(0).setPreferredWidth(25);
		thDl.getColumnModel().getColumn(1).setPreferredWidth(400);
		thDl.getColumnModel().getColumn(2).setPreferredWidth(175);
		thDl.getColumnModel().getColumn(3).setPreferredWidth(25);
		thDl.getColumnModel().getColumn(4).setPreferredWidth(45);
		thDl.getColumnModel().getColumn(5).setPreferredWidth(45);
		thDl.getColumnModel().getColumn(6).setPreferredWidth(50);
		thDl.getColumnModel().getColumn(7).setPreferredWidth(40);
		thDl.getColumnModel().getColumn(8).setPreferredWidth(50);
		thUl.getColumnModel().getColumn(0).setPreferredWidth(400);
		thUl.getColumnModel().getColumn(1).setPreferredWidth(130);
		thUl.getColumnModel().getColumn(2).setPreferredWidth(60);
		thUl.getColumnModel().getColumn(3).setPreferredWidth(30);
		thUl.getColumnModel().getColumn(4).setPreferredWidth(70);
		thUl.getColumnModel().getColumn(5).setPreferredWidth(70);
		thUl.getColumnModel().getColumn(6).setPreferredWidth(50);
		
		this.add(scrollPane);
		tablePane.add(labDl);
		tablePane.add(thDl);
		tablePane.add(tableDl);
		tablePane.add(labUl);
		tablePane.add(thUl);
		tablePane.add(tableUl);
		thDl.setPreferredSize(new Dimension(1266, 18));
		thUl.setPreferredSize(new Dimension(1266, 18));
		
		tableLayout.putConstraint(SpringLayout.WEST, labDl, 3, SpringLayout.WEST, tablePane);
		tableLayout.putConstraint(SpringLayout.NORTH, labDl, 3, SpringLayout.NORTH, tablePane);
		tableLayout.putConstraint(SpringLayout.WEST, thDl, 3, SpringLayout.WEST, tablePane);
		tableLayout.putConstraint(SpringLayout.NORTH, thDl, 3, SpringLayout.SOUTH, labDl);
		tableLayout.putConstraint(SpringLayout.WEST, tableDl, 3, SpringLayout.WEST, tablePane);
		tableLayout.putConstraint(SpringLayout.NORTH, tableDl, 3, SpringLayout.SOUTH, thDl);
		
		tableLayout.putConstraint(SpringLayout.WEST, labUl, 3, SpringLayout.WEST, tablePane);
		tableLayout.putConstraint(SpringLayout.NORTH, labUl, 3, SpringLayout.SOUTH, tableDl);
		tableLayout.putConstraint(SpringLayout.WEST, thUl, 3, SpringLayout.WEST, tablePane);
		tableLayout.putConstraint(SpringLayout.NORTH, thUl, 3, SpringLayout.SOUTH, labUl);
		tableLayout.putConstraint(SpringLayout.WEST, tableUl, 3, SpringLayout.WEST, tablePane);
		tableLayout.putConstraint(SpringLayout.NORTH, tableUl, 3, SpringLayout.SOUTH, thUl);
		
		//MouseListener zum sortieren nach gegebener Spalte
		thDl.addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent me) {
				int col = tableDl.columnAtPoint(new Point(me.getX(), me.getY()));
				col = tableDl.convertColumnIndexToModel(col);
				if (col == tmDl.getSortCol())
					tmDl.toggleInv();
				else 
					tmDl.setSortCol(col);
				tmDl.fireTableDataChanged();
			}
			public void mousePressed(MouseEvent arg0) {
			}
			public void mouseReleased(MouseEvent arg0) {
			}
			public void mouseEntered(MouseEvent arg0) {
			}
			public void mouseExited(MouseEvent arg0) {
			}});
		thUl.addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent me) {
				int col = tableUl.columnAtPoint(new Point(me.getX(), me.getY()));
				col = tableUl.convertColumnIndexToModel(col);
				if (col == tmUl.getSortCol()){
					tmUl.toggleInv();
					tmUl.fireTableDataChanged();
				}
				else {
					tmUl.setSortCol(col);
					tmUl.fireTableDataChanged();
				}
			}
			public void mousePressed(MouseEvent arg0) {
			}
			public void mouseReleased(MouseEvent arg0) {
			}
			public void mouseEntered(MouseEvent arg0) {
			}
			public void mouseExited(MouseEvent arg0) {
			}});
		
		//Setzen des TableRenderers
		tableDl.setDefaultRenderer(Object.class, new DlRenderer());
		tableUl.setDefaultRenderer(Object.class, new UlRenderer());
		
		//PoopUpMenu
		tableDl.addMouseListener(new MouseListener(){
			public void mouseClicked(MouseEvent me) {
				if (me.getButton()==MouseEvent.BUTTON3){
					int row = tableDl.rowAtPoint(new Point(me.getX(), me.getY()));
					tableDl.changeSelection(row, 0, false, false);
					JPopupMenu p = tmDl.getPopUp(row);
					tableDl.setComponentPopupMenu(p);
					p.show(tableDl, me.getX(), me.getY());
					tableDl.setComponentPopupMenu(null);
				}
			}
			public void mousePressed(MouseEvent me) {
			}
			public void mouseReleased(MouseEvent me) {
			}
			public void mouseEntered(MouseEvent me) {
			}
			public void mouseExited(MouseEvent me) {
			}});
	}
	
	public void run(){
		while (running){
			try {
				Thread.sleep(100);
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}
		}
		if (!connected){
			System.out.println("___keine_Verbindung___");
			reset();
			return;
		}
		running = true;
		String operation = "";
		if (eselURL.getFile().startsWith("/&"))
			operation = eselURL.getFile().substring(1);
		setAction("?ses=" + sesID + "&w=transfer&cat=0sort=dprogress" + operation);
		transAction(false, Thread.currentThread().getId());
		parseTransfer();
		tmDl.fireTableDataChanged();
		tmUl.fireTableDataChanged();
		setTPSize();
		running = false;
	}
	
	//Parsen des html-Codes
	private synchronized void parseTransfer(){
		try {
			StringBuffer tmpSb;
			tmpSb = getMySB(Thread.currentThread().getId());
			int i = EselMainVis.parseHeader(tmpSb);
			dlFile.clear();
			ulFile.clear();
			int n = 0;
			if (tmpSb.indexOf(String.valueOf(sesID))!=-1 && sesID!=0){
				System.out.println("..... parse Daten .....");
				for (; i<tmpSb.length() && i!=-1; n++){
					int end = tmpSb.indexOf("\n", i+1)==-1?tmpSb.length():tmpSb.indexOf("\n", i+1);
					String tmpStr = tmpSb.substring(i, end);
					i = end;
//					System.out.println(n + "|" + tmpStr.replace("\n",""));
					if (tmpStr.contains("<a href=\"#\" onMouseover=\"downmenu(event,'admin','")){
						Charset charset = Charset.forName("UTF-8");
						ByteBuffer bb = ByteBuffer.allocate(10240);
						bb.put(tmpStr.getBytes());
						bb.position(0);
						String tmpStr2 = charset.decode(bb).subSequence(0,2000).toString();
//						System.out.println(n + "|" + tmpStr2.replace("\n",""));
						DlFile tmpDlf =  new DlFile(tmpStr2);
						dlFile.add(tmpDlf);
						String tmpCmt = "is_halfnone.gif";
						double tmpSpeed = 0.0;
						String tmpPrio = "";
						String tmpCat = "";
						for (int j=0; j<12 && i<tmpSb.length() && i!=-1;j++){
							end = tmpSb.indexOf("\n", i+1)==-1?tmpSb.length():tmpSb.indexOf("\n", i+1);
							tmpStr = tmpSb.substring(i, end);
							i = end;
							if (tmpStr.contains("is_halfcmtgood.gif"))
								tmpCmt = "is_halfcmtgood.gif";
							else if (tmpStr.contains("is_halfcmtbad.gif"))
								tmpCmt = "is_halfcmtbad.gif";
							else if (tmpStr.contains("<td valign=top class=\"down-line-downloading-right\" nowrap>"))
								tmpSpeed = Double.parseDouble(tmpStr.substring(tmpStr.indexOf("nowrap>")+7, tmpStr.indexOf("</td>")));
							else if (tmpStr.contains("<td valign=top class=\"down-line-waiting-right\" nowrap>"))
								tmpSpeed = 0.0;
							else if (tmpStr.contains("downpriomenu"))
								tmpPrio = tmpStr.substring(tmpStr.indexOf("delayhidemenu()\">")+17, tmpStr.indexOf("</a>"));
							else if (tmpStr.contains("showmenu")){
								int tmpPos = tmpStr.indexOf("delayhidemenu()\">")+17;
								tmpCat = tmpStr.substring(tmpPos, tmpStr.indexOf("</a>", tmpPos));
							}
						}
						tmpDlf.setCmt(tmpCmt);
						tmpDlf.setSpeed(tmpSpeed);
						tmpDlf.setPriority(tmpPrio);
						tmpDlf.setCategory(tmpCat);
					}
					if (tmpStr.contains("onMouseover=\"upmenu")){
						Charset charset = Charset.forName("UTF-8");
						ByteBuffer bb = ByteBuffer.allocate(10240);
						bb.put(tmpStr.getBytes());
						bb.position(0);
						String tmpStr2 = charset.decode(bb).subSequence(0,2000).toString();
						UlFile tmpUlf = new UlFile(tmpStr2);
						ulFile.add(tmpUlf);
						double tmpSpeed = 0.0;
						for (int j=0; j<4 && i<tmpSb.length() && i!=-1;j++){
							end = tmpSb.indexOf("\n", i+1)==-1?tmpSb.length():tmpSb.indexOf("\n", i+1);
							tmpStr = tmpSb.substring(i, end);
							i = end;
							if (tmpStr.contains("<td valign=top class=\"up-line-uploading\" style=\"font-size: 7.5pt\">") && !tmpStr.contains(" / "))
								tmpSpeed = Double.parseDouble(tmpStr.substring(tmpStr.indexOf("7.5pt\">")+7, tmpStr.indexOf("</td>")));
							else if (tmpStr.contains("<td valign=top class=\"up-line-connecting\" style=\"font-size: 7.5pt\">") && !tmpStr.contains(" / "))
								tmpSpeed = 0.0;
						}
						tmpUlf.setSpeed(tmpSpeed);
					}
				}
			} else {
				disconnectModule(1);
				releaseSb(Thread.currentThread().getId());
				return;
			}
			tmDl.fireTableDataChanged();
			tmUl.fireTableDataChanged();
			setTPSize();
			releaseSb(Thread.currentThread().getId());
		} catch (StringBufferNotFoundExeption e) {
			reset();
			e.printStackTrace();
		}
	}
	
	public synchronized void reset(){
		dlFile.clear();
		ulFile.clear();
		tmDl.fireTableDataChanged();
		tmUl.fireTableDataChanged();
		setTPSize();
	}
	
	protected synchronized void disconnectModule(int type){
		if (type==0)
			System.out.println("(manuelle Trennung)");
		else
			System.out.println("(Trennung durch " + this.getClass().getSimpleName() + ")");
		super.disconnect(type);
	}
	
	//Tabellengre neu festlegen
	public synchronized void setTPSize(){
		labDl.setText("Downloads:   " + tableDl.getRowCount());
		labUl.setText("Uploads:   " + tableUl.getRowCount());
		tableDl.setPreferredSize(new Dimension(1266, tableDl.getRowHeight()*tableDl.getRowCount()));
		tableUl.setPreferredSize(new Dimension(1266, tableUl.getRowHeight()*tableUl.getRowCount()));
		tablePane.setPreferredSize(new Dimension(1266, 16 + labDl.getHeight()+thDl.getHeight()+(tableDl.getRowHeight()*tableDl.getRowCount())+labUl.getHeight()+thUl.getHeight()+(tableUl.getRowHeight()*tableUl.getRowCount())));
	}
	
	public static LinkedList getDlFile(){
		return dlFile;
	}
	
	public static LinkedList getUlFile(){
		return ulFile;
	}
	
	public DlTableModel getDlTM(){
		return tmDl;
	}

	//DL-Datei mit Parser 
	public class DlFile{
		
		private String name, hash, met, status, lastFullSeen, lastDl, ed2k, priority, category, comment;
		private double size, sizeOnDisk, downloaded, speed;
		private int sources, sourcesUsable, sourcesNNP, sourcesA4AF, fileParts,
			availableFileParts, downloadingFromXSources;
		
		public DlFile(String s){
			this.name = "<html>" + s.substring(s.indexOf("downmenu(event,'admin','")+24, s.indexOf("\\n")) + "</html>";
			this.hash = s.substring(s.indexOf("Hash:")+6, s.indexOf("\\nDateigre:"));
			String tmpSizePattern = "";
			if (s.contains("(Gre auf Disk:"))
				tmpSizePattern = "(Gre auf Disk:";
			else
				tmpSizePattern = "\\n&lt;br_head&gt;\\nTyp:";
			String tmpStr = s.substring(s.indexOf("Dateigre:")+12, s.indexOf(tmpSizePattern));
			if (tmpStr.contains("GB")){
				this.size = Double.parseDouble(tmpStr.replace("GB",""))*1024;
				this.size = cutDouble(size);
			}
			else if (tmpStr.contains("MB")){
				this.size = Double.parseDouble(tmpStr.replace("MB",""));
				this.size = cutDouble(size);
			}
			else if (tmpStr.contains("KB")){
				this.size = Double.parseDouble(tmpStr.replace("KB",""))/1024;
				this.size = cutDouble(size);
			}
			else if (tmpStr.contains("Bytes")){
				this.size = Double.parseDouble(tmpStr.replace("Bytes",""))/1024/1024;
				this.size = cutDouble(size);
			}
			else
				this.size = 0.0;
			if (s.contains("(Gre auf Disk:"))
				tmpStr = s.substring(s.indexOf("Gre auf Disk:")+16, s.indexOf(")\\n&lt;br_head&gt;\\nmet-Datei:"));
			else
				tmpStr = "";
			if (tmpStr.contains("GB")){
				this.sizeOnDisk = Double.parseDouble(tmpStr.replace("GB",""))*1024;
				this.sizeOnDisk = cutDouble(sizeOnDisk);
			}
			else if (tmpStr.contains("MB")){
				this.sizeOnDisk = Double.parseDouble(tmpStr.replace("MB",""));
				this.sizeOnDisk = cutDouble(sizeOnDisk);
			}
			else if (tmpStr.contains("KB")){
				this.sizeOnDisk = Double.parseDouble(tmpStr.replace("KB",""))/1024;
				this.sizeOnDisk = cutDouble(sizeOnDisk);
			}
			else if (tmpStr.contains("Bytes")){
				this.sizeOnDisk = Double.parseDouble(tmpStr.replace("Bytes",""))/1024/1024;
				this.sizeOnDisk = cutDouble(sizeOnDisk);
			}
			else
				this.sizeOnDisk = 0.0;
			if (s.contains("met-Datei:"))
				this.met = s.substring(s.indexOf("met-Datei:")+11, s.indexOf("\\nStatus:"));
			if (!s.contains("complete"))
				this.status = s.substring(s.indexOf("Status:")+8, s.indexOf("\\nFertiggestellt:"));
			else
				this.status = "Vollstndig";
			if (status.contains("Herunterladend"))
				this.downloadingFromXSources = Integer.parseInt(s.substring(s.indexOf("(von")+5, s.indexOf("Quellen)")-1));
			else
				this.downloadingFromXSources = 0;
			if (s.indexOf("Fertiggestellt:")!=-1){
				tmpStr = s.substring(s.indexOf("Fertiggestellt:")+16, s.indexOf("/"));
				if (tmpStr.contains("GB")){
					this.downloaded = Double.parseDouble(tmpStr.replace("GB",""))*1024;
					this.downloaded = cutDouble(downloaded);
				}
				else if (tmpStr.contains("MB")){
					this.downloaded = Double.parseDouble(tmpStr.replace("MB",""));
					this.downloaded = cutDouble(downloaded);
				}
				else if (tmpStr.contains("KB")){
					this.downloaded = Double.parseDouble(tmpStr.replace("KB",""))/1024;
					this.downloaded = cutDouble(downloaded);
				}
				else if (tmpStr.contains("Bytes")){
					this.downloaded = Double.parseDouble(tmpStr.replace("Bytes",""))/1024/1024;
					this.downloaded = cutDouble(downloaded);
				}
				else
					this.downloaded = 0.0;
			} else if (status == "Vollstndig")
				this.downloaded = this.size;
			if (!status.equals("Vollstndig")){
				this.sources = Integer.parseInt(s.substring(s.indexOf("Quellen:")+9, s.indexOf("(", s.indexOf("Quellen:"))-2));
				this.sourcesUsable = Integer.parseInt(s.substring(s.indexOf("(ntzlich:")+11, s.indexOf(", NNP:")));
				this.sourcesNNP = Integer.parseInt(s.substring(s.indexOf("NNP:")+5, s.indexOf(", A4AF:")));
				this.sourcesA4AF = Integer.parseInt(s.substring(s.indexOf("A4AF:")+6, s.indexOf(")\\nDateiteile:")));
				this.fileParts = Integer.parseInt(s.substring(s.indexOf("Dateiteile:")+12, s.indexOf(", verfgbar:")-1));
				int tmpAFP = s.indexOf(", verfgbar:");
				this.availableFileParts = Integer.parseInt(s.substring(tmpAFP+13, s.indexOf("(", tmpAFP)-1));
			} else {
				this.sources = -1;
				this.sourcesUsable = -1;
				this.sourcesNNP = -1;
				this.sourcesA4AF = -1;
				this.fileParts = -1;
				this.availableFileParts = -1;
			}
//			if (s.indexOf("'yes','no')\" onMouseout=\"delayhidemenu()\">")!=-1 || s.indexOf("'yes','yes')\" onMouseout=\"delayhidemenu()\">")!=-1)
//				this.comment = "yes";
//			else
//				this.comment = "no";
			if (s.contains("Komplett entdeckt:"))
				this.lastFullSeen = s.substring(s.indexOf("Komplett entdeckt:")+19, s.indexOf("\\nLetzter Empfang:"));
			this.lastDl = s.substring(s.indexOf("Letzter Empfang:")+17, s.indexOf("','ed2k:"));
			this.ed2k = s.substring(s.indexOf("ed2k:"), s.indexOf("','", s.indexOf("ed2k:")));
			this.priority = "";
			this.speed = 0.0;
			this.category = "";
		}

		public String getName(){
			return name;
		}
		
		public String getStatus(){
			return status;
		}
	
		public String getCategory() {
			return category;
		}
		
		private void setCategory(String cat) {
			this.category = cat;
		}
		
		public String getComment(){
			return comment;
		}
		public double getDownloaded() {
			return downloaded;
		}
	
		public int getDownloadingFromXSources() {
			return downloadingFromXSources;
		}
	
		public String getEd2k() {
			return ed2k;
		}
	
		public int getFileParts() {
			return fileParts;
		}
	
		public String getHash() {
			return hash;
		}
	
		public String getLastDl() {
			return lastDl;
		}
	
		public String getLastFullSeen() {
			return lastFullSeen;
		}
	
		public int getAvailableFileParts() {
			return availableFileParts;
		}
	
		public String getMet() {
			return met;
		}
	
		public String getPriority() {
			return priority;
		}
		
		private void setPriority(String prio) {
			this.priority = prio;
		}
	
		public double getSize() {
			return size;
		}
	
		public double getSizeOnDisk() {
			return sizeOnDisk;
		}
	
		public int getSources() {
			return sources;
		}
		
		public int getSourcesA4AF() {
			return sourcesA4AF;
		}
	
		public int getSourcesNNP() {
			return sourcesNNP;
		}
	
		public int getSourcesUsable() {
			return sourcesUsable;
		}
	
		public double getSpeed() {
			return speed;
		}
		
		private void setSpeed(double speed){
			this.speed = speed;
		}
		
		public void setCmt(String tmpCmt) {
			comment = tmpCmt;
		}
		
	}

	//UL-Datei mit Parser 
	public class UlFile{
		
		private String user, name, software, ulTime;
		private double ul, ulSes, dl, dlSes, speed; 
		
		public UlFile(String s){
			s = s.replace("<br>", "<br />");
			this.user = "<html>" + s.substring(s.indexOf("Name:")+6, s.indexOf("<br />Software:")) + "</html>";
			this.name = "<html>" + s.substring(s.indexOf("Upload:")+8, s.indexOf("<br /><br />Upload Zeit:")) + "</html>";
			this.software = s.substring(s.indexOf("Software:")+10, s.indexOf("<br />Angefordert"));
			this.ulTime = s.substring(s.indexOf("Zeit:")+6, s.indexOf("<br />bertragen:"));
			String tmpStr = s.substring(s.indexOf(".Upload:")+9, s.indexOf("(", s.indexOf(".Upload:")));
			if (tmpStr.contains("GB")){
				this.ul = Double.parseDouble(tmpStr.replace("GB",""))*1024;
				this.ul = cutDouble(ul);
			}
			else if (tmpStr.contains("MB")){
				this.ul = Double.parseDouble(tmpStr.replace("MB",""));
				this.ul = cutDouble(ul);
			}
			else if (tmpStr.contains("KB")){
				this.ul = Double.parseDouble(tmpStr.replace("KB",""))/1024;
				this.ul = cutDouble(ul);
			}
			else if (tmpStr.contains("Bytes")){
				this.ul = Double.parseDouble(tmpStr.replace("Bytes",""))/1024/1024;
				this.ul = cutDouble(ul);
			}			
			else
				this.ul = 0.0;
			tmpStr = s.substring(s.indexOf("(", s.indexOf(".Upload:"))+1, s.indexOf(")", s.indexOf(".Upload:")));
			if (tmpStr.contains("GB")){
				this.ulSes = Double.parseDouble(tmpStr.replace("GB",""))*1024;
				this.ulSes = cutDouble(ulSes);
			}
			else if (tmpStr.contains("MB")){
				this.ulSes = Double.parseDouble(tmpStr.replace("MB",""));
				this.ulSes = cutDouble(ulSes);
			}
			else if (tmpStr.contains("KB")){
				this.ulSes = Double.parseDouble(tmpStr.replace("KB",""))/1024;
				this.ulSes = cutDouble(ulSes);
			}
			else if (tmpStr.contains("Bytes")){
				this.ulSes = Double.parseDouble(tmpStr.replace("Bytes",""))/1024/1024;
				this.ulSes = cutDouble(ulSes);
			}
			else
				this.ulSes = 0.0;
			tmpStr = s.substring(s.indexOf("Download:")+10, s.indexOf("(", s.indexOf("Download:")));
			if (tmpStr.contains("GB")){
				this.dl = Double.parseDouble(tmpStr.replace("GB",""))*1024;
				this.dl = cutDouble(dl);
			}
			else if (tmpStr.contains("MB")){
				this.dl = Double.parseDouble(tmpStr.replace("MB",""));
				this.dl = cutDouble(dl);
			}
			else if (tmpStr.contains("KB")){
				this.dl = Double.parseDouble(tmpStr.replace("KB",""))/1024;
				this.dl = cutDouble(dl);
			}
			else if (tmpStr.contains("Bytes")){
				this.dl = Double.parseDouble(tmpStr.replace("Bytes",""))/1024/1024;
				this.dl = cutDouble(dl);
			}
			else
				this.dl = 0.0;
			tmpStr = s.substring(s.indexOf("(", s.indexOf("Download:"))+1, s.indexOf(")", s.indexOf("Download:")));
			if (tmpStr.contains("GB")){
				this.dlSes = Double.parseDouble(tmpStr.replace("GB",""))*1024;
				this.dlSes = cutDouble(dlSes);
			}
			else if (tmpStr.contains("MB")){
				this.dlSes = Double.parseDouble(tmpStr.replace("MB",""));
				this.dlSes = cutDouble(dlSes);
			}
			else if (tmpStr.contains("KB")){
				this.dlSes = Double.parseDouble(tmpStr.replace("KB",""))/1024;
				this.dlSes = cutDouble(dlSes);
			}
			else if (tmpStr.contains("Bytes")){
				this.dlSes = Double.parseDouble(tmpStr.replace("Bytes",""))/1024/1024;
				this.dlSes = cutDouble(dlSes);
			}
			else
				this.dlSes = 0.0;
		}
		
		public String getName() {
			return name;
		}
	
		public double getSpeed() {
			return speed;
		}
	
		private void setSpeed(double speed) {
			this.speed = speed;
		}
	
		public String getSoftware() {
			return software;
		}
	
		public String getUlTime() {
			return ulTime;
		}
	
		public String getUser() {
			return user;
		}

		public double getDl() {
			return dl;
		}

		public double getDlSes() {
			return dlSes;
		}

		public double getUl() {
			return ul;
		}

		public double getUlSes() {
			return ulSes;
		}
		
	}
	
	
	//Eigener TableCellRenderer wegen verschiedenen Objekten in der Tabelle
	//zB. String und ComboBox;
	private class DlRenderer implements TableCellRenderer{

		private static final long serialVersionUID = 1L;
		
		public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int col) {
			JComponent retCell;
			//TODO Ich wollte eigentlich die Kategorien in einer ComboBox in der Tabelle ndern lassen knnen...
			//d.h. if (col==8) ... JComboBox rendern
			//... aber wei noch ned wie! Also die ComboBox erscheint, lt sich aber nicht bedienen
			if (col==-100)
				retCell = new JComboBox();
			else
				retCell = new JLabel();
			retCell.setOpaque(true);
			if (value instanceof String){
				double tmpProgress = 0.0;
				tmpProgress = Double.parseDouble(((String) getDlTM().getValueAt(row, 0)).replace("%", "") + "")/100;
				int tmpGreen = 220;
				int tmpRed = 220;
				int tmpBlue = 220;
				double faktor = new Double(col).doubleValue()/new Double(getDlTM().getColumnCount()-1).doubleValue();
				if (tmpProgress>0.5){
					if (!isSelected){
						tmpGreen = 220 + (int)(35 * (tmpProgress-0.5) * 2 * (1 - faktor));
						tmpBlue = 220 + (int)(35 * faktor);
					} else {
						tmpGreen = 255;
						tmpRed = 255 - (int)(35 * (tmpProgress-0.5) * 2 * faktor);
					}
				} else {
					if (!isSelected){
						tmpRed = 220 + (int)(35 * (0.5-tmpProgress) * 2 * (1 - faktor));
						tmpBlue = 220 + (int)(35 * faktor);
					} else {
						tmpGreen = 255 - (int)(35 * (0.5-tmpProgress) * 2 * faktor);
						tmpRed = 255;
					}
				}
				retCell.setBackground(new Color(tmpRed, tmpGreen, tmpBlue));
				if (!isSelected){
					retCell.setFont(new Font("Verdana", Font.PLAIN, 12));
					if (getDlTM().getValueAt(row, 2).toString().contains("Herunterladend")){
						retCell.setForeground(new Color(55, 110, 0));
						retCell.setFont(new Font("Verdana", Font.BOLD, 12));
					} else if (getDlTM().getValueAt(row, 2).toString().contains("Vollstndig")){
						retCell.setForeground(new Color(255, 255, 255));
						retCell.setBackground(new Color(150, 200, 150));
					} else if (getDlTM().getValueAt(row, 2).toString().contains("Angehalten")){
						retCell.setForeground(new Color(255, 255, 255));
						retCell.setBackground(new Color(150, 150, 150));
					} else if (getDlTM().getValueAt(row, 2).toString().contains("Gestoppt")){
						retCell.setForeground(new Color(255, 255, 255));
						retCell.setBackground(new Color(200, 150, 150));
					} else {
						retCell.setForeground(new Color(0, 0, 0));
					}
				} else {
					retCell.setForeground(new Color(150, 75, 0));
					if (getDlTM().getValueAt(row, 2).toString().contains("Herunterladend"))
						retCell.setFont(new Font("Verdana", Font.BOLD, 12));
					else
						retCell.setFont(new Font("Verdana", Font.PLAIN, 12));
				}
				if (retCell instanceof JLabel && table.convertColumnIndexToModel(col)==1)
					((JLabel) retCell).setIcon(new ImageIcon(getClass().getResource((String) getDlTM().getValueAt(row, 10))));
				if (retCell instanceof JLabel)
					((JLabel) retCell).setText(value.toString());
				else if (retCell instanceof JComboBox){
					for (int i=0; i<EselMainVis.getCombCat().getItemCount(); i++)
						((JComboBox) retCell).addItem(EselMainVis.getCombCat().getItemAt(i));
					((JComboBox) retCell).setSelectedItem(((String) getDlTM().getValueAt(row, 8)));
				}
			}
			return retCell;
		}
		
	}
	
	private class UlRenderer implements TableCellRenderer{

		private static final long serialVersionUID = 1L;
		
		public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int col) {
			JLabel retCell = new JLabel();
			retCell.setOpaque(true);
			if (value instanceof String){
				retCell.setBackground(new Color(220, 220, 220));
				retCell.setForeground(new Color(0, 0, 0));
				retCell.setFont(new Font("Verdana", Font.PLAIN, 12));
				retCell.setText(value.toString());
			}
			if (isSelected){
				retCell.setBackground(new Color(220, 220, 220));
				retCell.setForeground(new Color(0, 0, 0));
			}
			return retCell;
		}
		
	}
	
}
