package remoteSystem;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GraphicsEnvironment;
import java.awt.Rectangle;
import java.awt.event.WindowEvent;
import java.awt.event.WindowFocusListener;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class TrayUploadThrottle extends JDialog{

	private static final long serialVersionUID = 1L;
	private JLabel ulLabel;
	private JSlider ulSlide;
	private Container cp;
	private boolean changed;

	public TrayUploadThrottle(){
		setAlwaysOnTop(true);
		setUndecorated(true);
		setSize(210, 20);
		setResizable(false);
		Rectangle max = GraphicsEnvironment.getLocalGraphicsEnvironment().getMaximumWindowBounds();
		setLocation(max.width-210, max.height-20);
		addWindowFocusListener(new WindowFocusListener(){
			public void windowGainedFocus(WindowEvent arg0) {
			}
			public void windowLostFocus(WindowEvent arg0) {
				setVisible(false);
				if (changed){
					Thread t = new Thread(new EselOpt(ulSlide.getValue()));
					t.setPriority(Thread.MIN_PRIORITY);
					t.start();
				}
			}
		});
		cp = this.getContentPane();
		cp.setLayout(new BorderLayout());
		cp.setBackground(new Color(255, 245, 220));
		JPanel cp2 = new JPanel();
		cp2.setLayout(new BorderLayout());
		cp2.setBackground(new Color(255, 200, 200));
		cp2.setPreferredSize(new Dimension(210, 20));
		cp2.setBorder(BorderFactory.createEtchedBorder(0));
		cp.add(cp2, BorderLayout.CENTER);
		int maxcapup = EselOpt.getMaxcapup();
		int maxup = EselOpt.getMaxup();
		if (maxup>maxcapup)
			maxup = maxcapup;
		ulSlide = new JSlider(JSlider.HORIZONTAL, 0, maxcapup, maxup);
		ulSlide.setMinorTickSpacing(1);
		ulSlide.setSnapToTicks(true);
		ulSlide.setBackground(new Color(255, 245, 235));
		ulSlide.setPreferredSize(new Dimension(167, 20));
		ulSlide.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent arg0) {
				ulLabel.setText(ulSlide.getValue() + "");
				changed = true;
			}});
		cp2.add(ulSlide, BorderLayout.EAST);
		ulLabel = new JLabel(ulSlide.getValue() + "");
//		ulLabel.setHorizontalAlignment(JLabel.CENTER);
		ulLabel.setFont(new Font("Verdana", Font.PLAIN, 11));
		ulLabel.setIcon(new ImageIcon(getClass().getResource("arrow_up.gif")));
		ulLabel.setOpaque(true);
		ulLabel.setBackground(new Color(255, 245, 235));
		ulLabel.setPreferredSize(new Dimension(37, 20));
		cp2.add(ulLabel, BorderLayout.WEST);
		changed = false;
		setVisible(true);
	}

}
