package remoteSystem;

import java.util.LinkedList;
import javax.swing.table.AbstractTableModel;
import remoteSystem.Transfer.UlFile;

public class UlTableModel extends AbstractTableModel{
	
	private static final long serialVersionUID = 1L;

	private LinkedList ulFile = Transfer.getUlFile();
	private String[][] data = new String[ulFile.size()][7];
	private String[] header = {"Name", "User", "Software", "Upload-Zeit", "Upload (Session)", "Download (Session)", "Geschwindigkeit"};
	private int sortCol = 0;
	private boolean inv = false;
	
	public UlTableModel(){
	}

	public int getSortCol() {
		return sortCol;
	}

	public void setSortCol(int col) {
		inv = false;
		sortCol = col;
	}
	
	public int getRowCount() {
		return data.length;
	}

	public int getColumnCount() {
		return 7;
	}

	public Object getValueAt(int row, int col) {
		return data[row][col];
	}
	
	public String getColumnName(int col){
		return header[col];
	}
	
	public synchronized void fireTableDataChanged(){
		getData();
		super.fireTableDataChanged();
	}
	
	private synchronized void getData(){
		data = new String[ulFile.size()][7];
		for (int i=0; i<ulFile.size(); i++){
			data[i][0] = ((UlFile) ulFile.get(i)).getName();
			data[i][1] = ((UlFile) ulFile.get(i)).getUser();
			data[i][2] = ((UlFile) ulFile.get(i)).getSoftware();
			data[i][3] = ((UlFile) ulFile.get(i)).getUlTime();
			data[i][4] = ((UlFile) ulFile.get(i)).getUl() + " MB (" + ((UlFile) ulFile.get(i)).getUlSes() + " MB)";
			data[i][5] = ((UlFile) ulFile.get(i)).getDl() + " MB (" + ((UlFile) ulFile.get(i)).getDlSes() + " MB)";
			data[i][6] = ((UlFile) ulFile.get(i)).getSpeed() + " MB/s";
		}
		sortData();
	}
	
	public synchronized void toggleInv(){
		inv = inv?false:true;
	}
	
	public synchronized void sortData(){
		if (data.length < 1 || data[0][0] == null)
			return;
		String[] tmpRow = new String[8];
		if (sortCol==4 || sortCol==5 || sortCol==6){
			for (int i=data.length; i>0; i--){
				for (int j=0; j<i-1; j++){
					if (!inv){
						if (Double.parseDouble(data[j][sortCol].substring(0, data[j][sortCol].indexOf("MB")))<Double.parseDouble(data[j+1][sortCol].substring(0, data[j+1][sortCol].indexOf("MB")))){
							tmpRow = data[j+1];
							data[j+1] = data[j];
							data[j] = tmpRow;
						}
					} else {
						if (Double.parseDouble(data[j][sortCol].substring(0, data[j][sortCol].indexOf("MB")))>Double.parseDouble(data[j+1][sortCol].substring(0, data[j+1][sortCol].indexOf("MB")))){
							tmpRow = data[j+1];
							data[j+1] = data[j];
							data[j] = tmpRow;
						}
					}
				}
			}
		} else {
			for (int i=data.length; i>0; i--){
				for (int j=0; j<i-1; j++){
					if (!inv){
						if (data[j][sortCol].compareToIgnoreCase(data[j+1][sortCol])>0){
							tmpRow = data[j+1];
							data[j+1] = data[j];
							data[j] = tmpRow;
						}
					} else {
						if (data[j][sortCol].compareToIgnoreCase(data[j+1][sortCol])<0){
							tmpRow = data[j+1];
							data[j+1] = data[j];
							data[j] = tmpRow;
						}
					}
				}
			}
		}
	}
	
}