package remoteSystem;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GraphicsEnvironment;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.URL;
import java.util.zip.GZIPInputStream;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class Update implements Runnable{
	
	private static String version = "v0.2c";
	private static boolean auto = false;
	
	public Update(){
	}
	
	public void run(){
		System.out.println("Update-Suche...");
		try {
			boolean isgzip = true;
			InputStream gzip = null;
			BufferedReader in;
			URL updateURL = new URL("http://www.1st-cybergen.de/extern/eselremote/eselremote.ver");
			try {
				gzip = new GZIPInputStream(updateURL.openStream());
			} catch (IOException e){
				isgzip = false;
			}
			if (isgzip){
				Reader gzipReader = new InputStreamReader(gzip);
				in = new BufferedReader(gzipReader);
			} else {
				Reader is = new InputStreamReader(updateURL.openStream());
				in = new BufferedReader(is);
			}
			String newVer = in.readLine();
			if (version.compareTo(newVer)<0){
				String dlUrl = in.readLine();
				askUpdate(dlUrl);
			} else {
				System.out.println("   kein Update vorhanden");
				if (!auto)
					noUpdate(false);
			}
			in.close();
			auto = false;
		} catch (IOException e) {
			System.out.println("Fehler beim Verbinden: " + e);
			if (!auto)
				noUpdate(true);
			auto = false;
		}
	}
	
	public static synchronized void setAuto(boolean auto1){
		auto = auto1;
	}
	
	public static String getVersion(){
		return version;
	}
	
	private void askUpdate(String dlUrl2) {
		final String dlUrl = dlUrl2;
		new JDialog(){
			private static final long serialVersionUID = 1L;
			{
				setModal(true);
				setAlwaysOnTop(true);
				setSize(360, 120);
				setResizable(false);
				Point center = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint();
				setLocation(new Double(center.getX()).intValue()-180, new Double(center.getY()).intValue()-60);
				setTitle("Update");
				setLayout(new BorderLayout());
				JLabel msg = new JLabel("<html><div align=\"center\">Es ist ein Update verfgbar!<br>Wollen sie zur Download-Seite von EselRemote gelangen?</div></html>");
				msg.setHorizontalAlignment(JLabel.CENTER);
				add(msg, BorderLayout.CENTER);
				JPanel btnPanel = new JPanel();
				btnPanel.setLayout(new BorderLayout());
				JButton btJa = new JButton("Ja");
				btJa.setPreferredSize(new Dimension(176, 25));
				btJa.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						try {
							String[] command = {"rundll32", "url.dll,FileProtocolHandler", dlUrl};
							new ProcessBuilder(command).start();
						} catch (IOException e) {
							System.out.println("Fehler beim starten des Prozesses: " + e);
						}
						setVisible(false);
					}});
				JButton btNein = new JButton("Nein");
				btNein.setPreferredSize(new Dimension(176, 25));
				btNein.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						setVisible(false);
					}});
				btnPanel.add(btJa, BorderLayout.WEST);
				btnPanel.add(btNein, BorderLayout.EAST);
				add(btnPanel, BorderLayout.SOUTH);
				setVisible(true);
			}
		};
	}
	
	private void noUpdate(boolean err2) {
		final boolean err = err2;
		new JDialog(){
			private static final long serialVersionUID = 1L;
			{
				setModal(true);
				setAlwaysOnTop(true);
				setSize(360, 120);
				setResizable(false);
				Point center = GraphicsEnvironment.getLocalGraphicsEnvironment().getCenterPoint();
				setLocation(new Double(center.getX()).intValue()-180, new Double(center.getY()).intValue()-60);
				setTitle("Update");
				setLayout(new BorderLayout());
				JLabel msg = new JLabel("<html><div align=\"center\">Es ist kein Update verfgbar.</div></html>");
				if (err)
					msg.setText("<html><div align=\"center\">Die Update-Suche ist fehlgeschlagen!<br>Versuchen Sie es spter...</div></html>");
				msg.setHorizontalAlignment(JLabel.CENTER);
				add(msg, BorderLayout.CENTER);
				JButton btJa = new JButton("OK");
				btJa.setPreferredSize(new Dimension(360, 25));
				btJa.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent arg0) {
						setVisible(false);
					}});
				add(btJa, BorderLayout.SOUTH);
				setVisible(true);
			}
		};
	}

}
